UXACC0   CSECT                                                          00001000
UXACC0   TITLE 'ALLOC GEDI Routine'                                     00002000
*                                                                       00003000
*  This routine requires SYS1.MACLIB to compile.  The High Level        00004000
*  Assembler was used by Thomson Software Products.                     00005000
*  The H-level assembler may work also.                                 00006000
         PRINT NOGEN                                                    00007000
UXACC0   AMODE 31                                                       00008000
UXACC0   RMODE ANY                                                      00009000
         MACRO                                                          00010000
         REGEQU                                                         00011000
         PUSH  PRINT                                                    00012000
         AIF   ('&SYSPARM' NE 'SUP').ACC01                              00013000
         PRINT OFF,NOGEN                                                00014000
.ACC01   ANOP                                                           00015000
         GBLB  &REGEQU1                                                 00016000
         AIF   (&REGEQU1 EQ 1).NOGEN                                    00017000
&REGEQU1 SETB  1                                                        00018000
*                                                                       00019000
***      SYMBOLIC REGISTER EQUATES                                      00020000
*                                                                       00021000
         SPACE 2                                                        00022000
* GENERAL PURPOSE REGISTERS                                             00023000
         SPACE                                                          00024000
R0       EQU   0                                                        00025000
R1       EQU   1                                                        00026000
R2       EQU   2                                                        00027000
R3       EQU   3                                                        00028000
R4       EQU   4                                                        00029000
R5       EQU   5                                                        00030000
R6       EQU   6                                                        00031000
R7       EQU   7                                                        00032000
R8       EQU   8                                                        00033000
R9       EQU   9                                                        00034000
R10      EQU   10                                                       00035000
R11      EQU   11                                                       00036000
R12      EQU   12                                                       00037000
R13      EQU   13                                                       00038000
R14      EQU   14                                                       00039000
R15      EQU   15                                                       00040000
         SPACE                                                          00041000
* FLOATING POINT REGISTERS                                              00042000
         SPACE                                                          00043000
F0       EQU   0                                                        00044000
F2       EQU   2                                                        00045000
F4       EQU   4                                                        00046000
F6       EQU   6                                                        00047000
         SPACE                                                          00048000
* EXTENDED CONTROL REGISTERS                                            00049000
         SPACE                                                          00050000
C0       EQU   0                                                        00051000
C1       EQU   1                                                        00052000
C2       EQU   2                                                        00053000
C3       EQU   3                                                        00054000
C4       EQU   4                                                        00055000
C5       EQU   5                                                        00056000
C6       EQU   6                                                        00057000
C7       EQU   7                                                        00058000
C8       EQU   8                                                        00059000
C9       EQU   9                                                        00060000
C10      EQU   10                                                       00061000
C11      EQU   11                                                       00062000
C12      EQU   12                                                       00063000
C13      EQU   13                                                       00064000
C14      EQU   14                                                       00065000
C15      EQU   15                                                       00066000
.NOGEN   ANOP                                                           00067000
         POP   PRINT                                                    00068000
         MEXIT                                                          00069000
         MEND                                                           00070000
         MACRO                                                          00071000
&LAB     $ICALL &WHERE,&BASE=R15,&RET=R14                               00072000
.*   $ICALL ABC         --> L    R15,=A(ABC)                            00073000
.*                          BALR R14,R15                                00074000
.*                                                                      00075000
.*   $ICALL ABC,RET=R9  --> L    R15,=A(ABC)                            00076000
.*                          BALR R9,R15                                 00077000
.*                                                                      00078000
.*   $ICALL ABC,RET=R8  --> L    R15,=A(ABC)                            00079000
.*                          BALR R8,R15                                 00080000
.*                                                                      00081000
         LCLC  &LABL                                                    00082000
&LABL    SETC  '&LAB'                                                   00083000
         AIF   ('&WHERE' EQ '('.'&WHERE(1)'.')').LR                     00084000
&LABL    ICM   &BASE,15,=A(&WHERE)                                      00085000
&LABL    SETC  ''                                                       00086000
         AGO   .COM                                                     00087000
.LR      ANOP ,                                                         00088000
         AIF   ('&WHERE(1)' EQ '15').COM                                00089000
         AIF   ('&WHERE(1)' EQ 'R15').COM                               00090000
         AIF   ('&BASE' EQ '&WHERE(1)').COM                             00091000
&LABL    LR    &BASE,&WHERE(1)                                          00092000
&LABL    SETC  ''                                                       00093000
.COM     AIF   ('&RET' EQ '').BALR14                                    00094000
&LABL    BALR  &RET,&BASE                                               00095000
         MEXIT                                                          00096000
.BALR14  ANOP  ,                                                        00097000
         MNOTE 2,'RET= is not specified, set to R14'                    00098000
&LABL    BALR  R14,&BASE                                                00099000
         MEND                                                           00100000
         SPACE ,                                                        00101000
GLOBNAV  EQU   X'80'          Define global NAV value                   00102000
         REGEQU                                                         00103000
         EJECT ,                                                        00104000
*********************************************************************** 00105000
*********************************************************************** 00106000
*                                                                     * 00107000
*                             D S E C T S                             * 00108000
*                                                                     * 00109000
*********************************************************************** 00110000
*********************************************************************** 00111000
         PRINT NOGEN                                                    00112000
         SPACE 3                                                        00113000
         DCBD  DSORG=PS                                                 00114000
         PRINT GEN,MSOURCE                                              00115000
FILE_DEF    DSECT ,     FILE_DEF MASTER Record description              00116000
FD_DDNAME   DS   CL8    DDNAME                                          00117000
         SPACE ,                                                        00118000
FD_DEVTYPE  DS   CL2    Device type:                                    00119000
FD_DEVTYPE_DI EQU  C'DI'  Disk                                          00120000
FD_DEVTYPE_TA EQU  C'TA'  Tape                                          00121000
FD_DEVTYPE_TE EQU  C'TE'  Terminal                                      00122000
FD_DEVTYPE_PT EQU  C'PT'  Printer                                       00123000
FD_DEVTYPE_PO EQU  C'PO'  Library                                       00124000
FD_DEVTYPE_OT EQU  C'OT'  Other                                         00125000
FD_DEVTYPE_VS EQU  C'VS'  VSAM                                          00126000
FD_DEVTYPE_SY EQU  C'SY'  SYSOUT                                        00127000
         SPACE ,                                                        00128000
FD_DSNAME    DS   CL44                                                  00129000
         SPACE ,                                                        00130000
FD_MEMBER    DS   CL8    Member name if FD_DEVTYPE='PO'                 00131000
         SPACE ,                                                        00132000
FD_MVS_DISP   DS  CL3    ALLOC/JCL Disposition                          00133000
FD_SPACE_HOW  DS  CL3    Space type                                     00134000
FD_VOLSER     DS  5CL6                                                  00135000
FD_UNIT       DS  CL8                                                   00136000
         SPACE ,                                                        00137000
FD_RECFM     DS   CL4    RECFM                                          00138000
FD_LRECL     DS   H      LRECL                                          00139000
FD_BLKSIZE   DS   H      BLKSIZE                                        00140000
FD_BUFNO     DS   H      BUFNO                                          00141000
FD_MDATAL     EQU  *-FD_DDNAME    Actual length of data                 00142000
         SPACE ,                                                        00143000
              DS   0D                                                   00144000
FD_NADDR     DS   F      -> next data segment                           00145000
              DS   0D                                                   00146000
FD_MLEN      EQU  *-FD_DDNAME       length of dependent segment         00147000
DBUFMAX      EQU  (4096-8)/FD_MLEN    How many we get in a 4K page      00148000
         SPACE 3                                                        00149000
*********************************************************************** 00150000
*                                                                     * 00151000
*             G E D I   U S E R   E X I T   R O U T I N E             * 00152000
*                                                                     * 00153000
*                           P A R M L I S T                           * 00154000
*                                                                     * 00155000
*********************************************************************** 00156000
         SPACE 3                                                        00157000
GEDIPARM DSECT                                                          00158000
         SPACE 2                                                        00159000
SEGNAM   DS    A                                                        00160000
OPCODE   DS    A                                                        00161000
RC       DS    A                                                        00162000
BUFFAD   DS    A                                                        00163000
BUFLEN   DS    A                                                        00164000
KEYBUF   DS    A                                                        00165000
KEYLEN   DS    A                                                        00166000
INFO     DS    A                                                        00167000
INFLEN   DS    A                                                        00168000
SORTFL   DS    A                                                        00169000
N2VERN   DS    A                                                        00170000
USVERN   DS    A                                                        00171000
USWD     DS    A                                                        00172000
DBNAME   DS    A                                                        00173000
PARENT   DS    A                                                        00174000
IBUFAD   DS    A                                                        00175000
IBUFLN   DS    A                                                        00176000
PREVFL   DS    A                                                        00177000
LASTFL   DS    A                                                        00178000
N2WRIT   DS    A                                                        00179000
USWRIT   DS    A                                                        00180000
         SPACE 3                                                        00181000
GEDIPLEN EQU   *-GEDIPARM              Length of parmlist               00182000
         SPACE 3                                                        00183000
         IHAPSA                                                         00184000
         SPACE 3                                                        00185000
         IKJTCB                                                         00186000
         SPACE 3                                                        00187000
         CVT    DSECT=YES                                               00188000
         SPACE 3                                                        00189000
         IEZDEB                                                         00190000
         SPACE 3                                                        00191000
TIOTDS   DSECT                                                          00192000
         IEFTIOT1                                                       00193000
         SPACE 3                                                        00194000
JFCBDS   DSECT                                                          00195000
         IEFJFCBN LIST=YES                                              00196000
         EJECT                                                          00197000
*********************************************************************** 00198000
*                                                                     * 00199000
*                     L O C A L   W O R K A R E A                     * 00200000
*                                                                     * 00201000
*********************************************************************** 00202000
         SPACE 3                                                        00203000
WKAREADS DSECT                                                          00204000
         SPACE 1                                                        00205000
         DS    18F                     OS Savearea                      00206000
         SPACE 1                                                        00207000
WKDBLWD  DS    D                       Doubleword workarea              00208000
WKBUFADR DS    A                       A(Buffer)                        00209000
WKBUFLEN DS    F                       Buffer length                    00210000
WKFIDCNT DS    F                       FID  count                       00211000
WK1FID   DS    A                       -> First FID                     00212000
WKCURFID DS    A                       -> Current FID                   00213000
WKCURSEG DS    A                       -> data segment                  00214000
WKXFIDBF DS    A                       -> FID Instance Buffer           00215000
WKXDATBF DS    A                       -> data segment Instance Buffer  00216000
WKFIDSUB DS    A                       $FREE subpool anchor             00217000
WKSEGSUB DS    A                                                        00218000
WKRKEY   DS    CL16                    Last RKEY FILE_ID                00219000
         SPACE 1                                                        00220000
JFWKDCB  DCB   DSORG=PS,MACRF=GL                                        00221000
JFWKPLST RDJFCB (*),MF=L                                                00222000
JFWKXLST DS    A                                                        00223000
JFWKJFCB DS    CL(JFCBLGTH)                                             00224000
         SPACE 1                                                        00225000
WKSAVE01 DS    18F                     Subroutine savearea              00226000
WKSAVE02 DS    18F                     Subroutine savearea              00227000
WKSAVE03 DS    18F                     Subroutine savearea              00228000
WKSAVE04 DS    18F                     Subroutine savearea              00229000
WKSAVE05 DS    18F                     Subroutine savearea              00230000
WKSAVE06 DS    18F                     Subroutine savearea              00231000
         SPACE 3                                                        00232000
         DS    0D                                                       00233000
WKAREALN EQU   *-WKAREADS              Workarea length                  00234000
         EJECT                                                          00235000
UXACC0   CSECT ,                                                        00236000
*                                                                       00237000
*********************************************************************** 00238000
*                                                                     * 00239000
*     This program functions as a GEDI User Exit Routine to map       * 00240000
*         ALLOC   information as a database.                          * 00241000
*                                                                     * 00242000
*     Multiple concurrent users are supported through the USWD        * 00243000
*     feature of GEDI, which allows us to maintain separate areas     * 00244000
*     for each user of the database.                                  * 00245000
*                                                                     * 00246000
*                                                                     * 00247000
*     This program is reentrant.                                      * 00248000
*                                                                     * 00249000
*********************************************************************** 00250000
*                                                                       00251000
         EJECT                                                          00252000
*********************************************************************** 00253000
*********************************************************************** 00254000
*                                                                     * 00255000
*                      P R O C E S S   N O T E S                      * 00256000
*                                                                     * 00257000
*********************************************************************** 00258000
*********************************************************************** 00259000
         EJECT                                                          00260000
*********************************************************************** 00261000
*********************************************************************** 00262000
*                                                                     * 00263000
*                      E N T R Y   L I N K A G E                      * 00264000
*                                                                     * 00265000
*********************************************************************** 00266000
*********************************************************************** 00267000
         SPACE 3                                                        00268000
         USING UXACC0,R15              Temporary addressability         00269000
         B     SAVEREGS                Branch around eyecatcher         00270000
         DC    CL8'UXACC0'                                              00271000
         DC    CL8'&SYSDATE'                                            00272000
         DC    CL8'&SYSTIME'                                            00273000
SAVEREGS EQU   *                                                        00274000
         STM   R14,R12,12(R13)         Save caller's registers          00275000
         LR    R11,R15                 Set up our base register         00276000
         DROP  R15                     Was UXMVSCAT                     00277000
         USING UXACC0,R11              Establish addressability         00278000
         LR    R9,R1                   Get parmlist address             00279000
         USING GEDIPARM,R9             Establish addressability         00280000
         L     R3,USWD                                                  00281000
         LR    R4,R13                  Save incoming address            00282000
         ICM   R2,B'1111',0(R3)        Workarea already exist ?         00283000
         BNZ   GOTWKAR                 If so, use it                    00284000
         GETMAIN RU,LV=WKAREALN+FD_MLEN,LOC=BELOW                       00285000
         LR    R2,R1                   Save the address                 00286000
         USING WKAREADS,R2             Establish addressability         00287000
         ST    R2,0(,R3)               Save for future calls            00288000
         LA    R5,WKAREALN(,R2)        -> buffer                        00289000
         ST    R5,WKBUFADR             Save the ->                      00290000
         LA    R5,FD_MLEN                                               00291000
         ST    R5,WKBUFLEN                                              00292000
         XC    WKFIDCNT,WKFIDCNT                                        00293000
         XC    WKCURFID,WKCURFID                                        00294000
         XC    WKFIDSUB,WKFIDSUB                                        00295000
         XC    WKSEGSUB,WKSEGSUB                                        00296000
         DROP  R2                      Was WKAREADS                     00297000
GOTWKAR  DS    0H                                                       00298000
         ST    R2,8(,R4)               Chain the saveareas              00299000
         ST    R4,4(,R2)                                                00300000
         LR    R13,R2                  Get ours to R13                  00301000
         USING WKAREADS,R13            Establish addressability         00302000
         EJECT                                                          00303000
*********************************************************************** 00304000
*                                                                     * 00305000
*                 D E T E R M I N E   F U N C T I O N                 * 00306000
*                                                                     * 00307000
*********************************************************************** 00308000
         SPACE 3                                                        00309000
DETFUNC  DS    0H                                                       00310000
*                                                                       00311000
*     This section routes control based on the function code.           00312000
*                                                                       00313000
         L     R15,OPCODE              Get function code                00314000
         L     R15,0(,R15)                                              00315000
         SLL   R15,2                   Convert to fullword offset       00316000
         A     R15,=A(OPCTABLE)        Get routine slot address         00317000
         ICM   R15,B'1111',0(R15)      Get routine address              00318000
         BNZR  R15                     If it exists, use it             00319000
         LA    R15,12                   else, give RC 12                00320000
         L     R14,RC                                                   00321000
         ST    R15,0(,R14)                                              00322000
         L     R13,4(,R13)                                              00323000
         LM    R14,R12,12(R13)                                          00324000
         BR    R14                                                      00325000
         SPACE 3                                                        00326000
         LTORG                                                          00327000
         EJECT                                                          00328000
*********************************************************************** 00329000
*********************************************************************** 00330000
*                                                                     * 00331000
*                               O P E N                               * 00332000
*                                                                     * 00333000
*********************************************************************** 00334000
*********************************************************************** 00335000
         SPACE 3                                                        00336000
OPEN     DS    0H                                                       00337000
*                                                                       00338000
*     For OPEN, we don't need to do anything?                           00339000
*                                                                       00340000
         LR    R11,R15                 Set up base register             00341000
         USING OPEN,R11                Establish addressability         00342000
         L     R15,USWRIT              -> writable switch               00343000
         XC    0(4,R15),0(R15)         And set it off                   00344000
         L     R15,PREVFL              -> previousable switch           00345000
         XC    0(4,R15),0(R15)         And set it off                   00346000
         L     R15,LASTFL              -> lastable switch               00347000
         XC    0(4,R15),0(R15)         And set it off                   00348000
         SPACE ,                                                        00349000
OPENRTRN DS    0H                      Return to caller                 00350000
         SR    R15,R15                 Get an error                     00351000
         L     R14,RC                  Set return code                  00352000
         ST    R15,0(,R14)                                              00353000
         LA    R15,1                   Set SORTFL to 1                  00354000
         L     R14,SORTFL                                               00355000
         ST    R15,0(,R14)                                              00356000
         L     R14,USVERN              Set USVERN to 1                  00357000
         ST    R15,0(,R14)                                              00358000
         L     R13,4(,R13)             Restore caller's savearea        00359000
         LM    R14,R12,12(R13)         Restore his registers            00360000
         BR    R14                     Return                           00361000
         SPACE 3                                                        00362000
         LTORG                                                          00363000
         EJECT                                                          00364000
*********************************************************************** 00365000
*********************************************************************** 00366000
*                                                                     * 00367000
*                              C L O S E                              * 00368000
*                                                                     * 00369000
*********************************************************************** 00370000
*********************************************************************** 00371000
         SPACE 3                                                        00372000
CLOSE    DS    0H                                                       00373000
*                                                                       00374000
*     For CLOSE, we do nothing.                                         00375000
*                                                                       00376000
         LR    R11,R15                 Set up base register             00377000
         USING CLOSE,R11               Establish addressability         00378000
         SPACE ,                                                        00379000
CLOSRTRN DS    0H                      Return to caller                 00380000
         SR    R15,R15                 Set return code                  00381000
         L     R14,RC                                                   00382000
         ST    R15,0(,R14)                                              00383000
         L     R13,4(,R13)             Get caller's savearea            00384000
         LM    R14,R12,12(R13)         Restore his registers            00385000
         BR    R14                     Return                           00386000
         SPACE 3                                                        00387000
         LTORG                                                          00388000
         EJECT                                                          00389000
*********************************************************************** 00390000
*********************************************************************** 00391000
*                                                                     * 00392000
*                           S H U T D O W N                           * 00393000
*                                                                     * 00394000
*********************************************************************** 00395000
*********************************************************************** 00396000
         SPACE 3                                                        00397000
SHUTDOWN DS    0H                                                       00398000
*                                                                       00399000
*     For SHUTDOWN, we get rid of all of the data buffers and our       00400000
*     work area.                                                        00401000
*                                                                       00402000
         LR    R11,R15                 Set up base register             00403000
         USING SHUTDOWN,R11            Establish addressability         00404000
         SPACE 1                                                        00405000
         ICM   R1,15,WKFIDSUB          Do we have any storage?          00406000
         BZ    SHUT_RTRN               No                               00407000
         $ICALL DELLEVEL               YES, go delete all entries       00408000
         SPACE 1                                                        00409000
SHUT_RTRN    DS   0H                                                    00410000
         SR    R15,R15                 Set return code                  00411000
         L     R14,RC                                                   00412000
         ST    R15,0(,R14)                                              00413000
         L     R14,USWD                Clear workarea pointer           00414000
         ST    R15,0(,R14)                                              00415000
         LR    R1,R13                  Save workarea address            00416000
         L     R4,4(,R13)              Get caller's savearea            00417000
         L     R0,=A((WKAREALN+FD_MLEN))                                00418000
         FREEMAIN R,LV=(0),A=(1)                                        00419000
         DROP  R13                                                      00420000
         LR    R13,R4                                                   00421000
         LM    R14,R12,12(R13)         Restore his registers            00422000
         BR    R14                     Return                           00423000
         SPACE 3                                                        00424000
         LTORG                                                          00425000
         EJECT                                                          00426000
         USING WKAREADS,R13            Since we overrode this above     00427000
*********************************************************************** 00428000
*********************************************************************** 00429000
*                                                                     * 00430000
*                              F I R S T                              * 00431000
*                                                                     * 00432000
*********************************************************************** 00433000
*********************************************************************** 00434000
         SPACE 3                                                        00435000
FIRST    DS    0H                                                       00436000
*                                                                       00437000
*     For FIRST, we delete all the data buffers.                        00438000
*     We then call GETRECRD to get the next record.                     00439000
*                                                                       00440000
         LR    R11,R15                 Set up base register             00441000
         USING FIRST,R11               Establish addressability         00442000
         SPACE ,                                                        00443000
         ICM   R15,15,PARENT           Find out if FIRST MASTER         00444000
         BZ    FRSTERR                 Ooops, shouldn't be zero         00445000
         SPACE ,                                                        00446000
         ICM   R1,15,WKFIDSUB          Do we have any storage?          00447000
         BZ    FRST_START              No                               00448000
         $ICALL DELLEVEL               YES, go delete all entries       00449000
         SPACE ,                                                        00450000
FRST_START   DS    0H                                                   00451000
         XC    WK1FID,WK1FID           Clear the pointers               00452000
         XC    WKCURFID,WKCURFID       and this                         00453000
         XC    WKCURSEG,WKCURSEG                                        00454000
         XC    WKXFIDBF,WKXFIDBF                                        00455000
         XC    WKXDATBF,WKXDATBF                                        00456000
         XC    WKRKEY,WKRKEY                                            00457000
         SPACE ,                                                        00458000
         $ICALL GETRECRD                                                00459000
         LTR   R15,R15                 Is RC zero?                      00460000
         BNZ   FRSTRTRN                No, just return                  00461000
         SPACE ,                                                        00462000
         L     R5,WK1FID               -> first record                  00463000
         L     R4,WKBUFADR             -> buffer                        00464000
         L     R15,BUFFAD              -> where to store it             00465000
         ST    R4,0(,R15)              Save                             00466000
         L     R14,=A(FD_MDATAL)      Get length                        00467000
         L     R15,BUFLEN              -> where to store it             00468000
         ST    R14,0(,R15)             Save                             00469000
         MVC   0(FD_MDATAL,R4),0(R5)  Move the data to work buffer      00470000
         SR    R15,R15                 Get return code                  00471000
         B     FRSTRTRN                And return                       00472000
         SPACE ,                                                        00473000
FRSTRTRN DS    0H                                                       00474000
         L     R14,RC                                                   00475000
         ST    R15,0(,R14)                                              00476000
         L     R13,4(,R13)             Get caller's savearea            00477000
         LM    R14,R12,12(R13)         Restore his registers            00478000
         BR    R14                     Return                           00479000
         SPACE ,                                                        00480000
FRSTERR  DS    0H                      return an i/o error              00481000
         L     R15,=F'8'                                                00482000
         B     FRSTRTRN                And return                       00483000
         SPACE 3                                                        00484000
         LTORG                                                          00485000
         EJECT                                                          00486000
*********************************************************************** 00487000
*********************************************************************** 00488000
*                                                                     * 00489000
*                               L A S T                               * 00490000
*                                                                     * 00491000
*********************************************************************** 00492000
*********************************************************************** 00493000
         SPACE 3                                                        00494000
LAST     DS    0H                                                       00495000
*                                                                       00496000
*     We don't support LAST so return the invalid function code.        00497000
*                                                                       00498000
         LR    R11,R15                 Set up base register             00499000
         USING LAST,R11                Establish addressability         00500000
         L     R15,=F'12'              Set RC to BAD                    00501000
         L     R14,RC                                                   00502000
         ST    R15,0(,R14)                                              00503000
         L     R13,4(,R13)             Get caller's savearea            00504000
         LM    R14,R12,12(R13)         Restore his registers            00505000
         BR    R14                     Return                           00506000
         SPACE 3                                                        00507000
         LTORG                                                          00508000
         EJECT                                                          00509000
*********************************************************************** 00510000
*********************************************************************** 00511000
*                                                                     * 00512000
*                               N E X T                               * 00513000
*                                                                     * 00514000
*********************************************************************** 00515000
*********************************************************************** 00516000
         SPACE 3                                                        00517000
NEXT     DS    0H                                                       00518000
*                                                                       00519000
*     For NEXT, we just call GETRECRD.                                  00520000
*                                                                       00521000
*     If the immediately previous command was an RKEY, then we will     00522000
*     get a new copy (by default since WK1FID is 0).  A new copy is     00523000
*     then built by GETRECRD.  Once we return, we position within       00524000
*     the new copy to the next MASTER after the WKRKEY value.           00525000
*                                                                       00526000
         LR    R11,R15                 Set up base register             00527000
         USING NEXT,R11                Establish addressability         00528000
         SPACE ,                                                        00529000
         ICM   R15,15,PARENT           Find out if FIRST MASTER         00530000
         BZ    NEXTERR                 Ooops, shouldn't be zero         00531000
         CLI   WKRKEY,0                Are we NEXTing after RKEY?       00532000
         BE    NEXT_RECORD             No, just continue                00533000
         XC    WKCURFID,WKCURFID       Yes, force refresh               00534000
         SPACE ,                                                        00535000
NEXT_RECORD   DS     0H                                                 00536000
         $ICALL GETRECRD                                                00537000
         LTR   R15,R15                 Is RC zero?                      00538000
         BNZ   NEXTRTRN                No, just return                  00539000
         CLI   WKRKEY,0                Are we NEXTing after RKEY?       00540000
         BE    NEXT_MASTER             No, continue                     00541000
         L     R3,WKCURFID             Yes, -> first                    00542000
         USING FILE_DEF,R3             Define the base                  00543000
         SPACE ,                                                        00544000
*                                                                       00545000
*  We are NEXTing after an RKEY.  This means that we must be positioned 00546000
*  by this RKEY value.                                                  00547000
*                                                                       00548000
NEXT_NEXT     DS     0H                                                 00549000
         CLC   FD_DDNAME,WKRKEY        Is this the one?                 00550000
         BE    NEXT_NEXT_END           Yes, go to next                  00551000
         ICM   R3,15,FD_NADDR          No -> next                       00552000
         BNZ   NEXT_NEXT               And loop                         00553000
         B     NEXTEOF                 Not found = EOF                  00554000
         SPACE ,                                                        00555000
NEXT_NEXT_END DS     0H                                                 00556000
         ICM   R3,15,FD_NADDR         No -> next                        00557000
         BZ    NEXTEOF                 Not found = EOF                  00558000
         ST    R3,WKCURFID             Save this one as next            00559000
         DROP  R3                                                       00560000
         SPACE ,                                                        00561000
NEXT_MASTER   DS     0H                                                 00562000
         XC    WKRKEY,WKRKEY           No more RKEY                     00563000
         L     R5,WKCURFID             -> current record                00564000
         L     R4,WKBUFADR             -> buffer                        00565000
         L     R15,BUFFAD              -> where to store it             00566000
         ST    R4,0(,R15)              Save                             00567000
         L     R14,=A(FD_MDATAL)      Get length                        00568000
         L     R15,BUFLEN              -> where to store it             00569000
         ST    R14,0(,R15)             Save                             00570000
         MVC   0(FD_MDATAL,R4),0(R5)  Move the data to work buffer      00571000
         SR    R15,R15                 Set RC to zero                   00572000
         B     NEXTRTRN                And return                       00573000
         SPACE ,                                                        00574000
NEXTEOF       DS   0H                  No MASTER                        00575000
         XC    WKRKEY,WKRKEY           No more RKEY                     00576000
         LA    R15,4                   EOF error                        00577000
         B     NEXTRTRN                And return                       00578000
         SPACE ,                                                        00579000
NEXTRTRN DS    0H                                                       00580000
         L     R14,RC                                                   00581000
         ST    R15,0(,R14)                                              00582000
         L     R13,4(,R13)             Get caller's savearea            00583000
         LM    R14,R12,12(R13)         Restore his registers            00584000
         BR    R14                     Return                           00585000
         SPACE ,                                                        00586000
NEXTERR  DS    0H                      return an i/o error              00587000
         L     R15,=F'8'                                                00588000
         B     NEXTRTRN                And return                       00589000
         SPACE 3                                                        00590000
         LTORG                                                          00591000
         EJECT                                                          00592000
*********************************************************************** 00593000
*********************************************************************** 00594000
*                                                                     * 00595000
*                           P R E V I O U S                           * 00596000
*                                                                     * 00597000
*********************************************************************** 00598000
*********************************************************************** 00599000
         SPACE 3                                                        00600000
PREVIOUS DS    0H                                                       00601000
*                                                                       00602000
*     We don't support PREVIOUS, so just return an invalid function     00603000
*     return code.                                                      00604000
*                                                                       00605000
         LR    R11,R15                 Set up base register             00606000
         USING PREVIOUS,R11            Establish addressability         00607000
         L     R15,=F'12'              Return BAD                       00608000
         L     R14,RC                                                   00609000
         ST    R15,0(,R14)                                              00610000
         L     R13,4(,R13)             Get caller's savearea            00611000
         LM    R14,R12,12(R13)         Restore his registers            00612000
         BR    R14                     Return                           00613000
         SPACE 3                                                        00614000
         LTORG                                                          00615000
         EJECT                                                          00616000
*********************************************************************** 00617000
*********************************************************************** 00618000
*                                                                     * 00619000
*                               R K E Y                               * 00620000
*                                                                     * 00621000
*********************************************************************** 00622000
*********************************************************************** 00623000
         SPACE 3                                                        00624000
RKEY     DS    0H                                                       00625000
*                                                                       00626000
*     Before RKEYing, we need to get rid of any data that exists.       00627000
*                                                                       00628000
         LR    R11,R15                 Set up base register             00629000
         USING RKEY,R11                Establish addressability         00630000
         SPACE ,                                                        00631000
         ICM   R15,15,PARENT           Find out if MASTER               00632000
         BZ    RKEYERR                 Ooops, shouldn't be zero         00633000
         ICM   R3,15,WK1FID            See if any MASTERs               00634000
         BNZ   RKEY_FIRST              We have to get rid of these      00635000
         B     RKEY_MASTER             None, so we can find this one    00636000
         SPACE ,                                                        00637000
RKEY_FIRST     DS  0H                                                   00638000
         $ICALL DELLEVEL                                                00639000
         LTR   R15,R15                 Is RC zero?                      00640000
         BNZ   RKEYRTRN                No, just return                  00641000
         SPACE ,                                                        00642000
*                                                                       00643000
*  We are doing a MASTER, and any old data is gone.  Get the key        00644000
*  value into the work area.  Then try to find it walking the           00645000
*  operating system (TIOT for MVS) chain.                               00646000
*                                                                       00647000
RKEY_MASTER    DS  0H                                                   00648000
         L     R2,KEYBUF               -> incoming value                00649000
         L     R3,KEYLEN               -> its length                    00650000
         L     R3,0(,R3)               And get the length               00651000
         LA    R0,WKRKEY               -> our work area                 00652000
         L     R1,=A(L'WKRKEY)         Get its length                   00653000
         ICM   R1,8,=C' '              Clear to blanks                  00654000
         ICM   R3,8,=C' '              Clear to blanks                  00655000
         MVCL  R0,R2                   Move value to work area          00656000
         SR    R2,R2                                                    00657000
         SPACE ,                                                        00658000
*********************************************************************** 00659000
*                                                                     * 00660000
*                      S C A N   T H E   T I O T                      * 00661000
*                                                                     * 00662000
*********************************************************************** 00663000
         USING PSA,R0                                                   00664000
         SPACE ,                                                        00665000
SCAN2    EQU   *                                                        00666000
*                                                                       00667000
*     This section scans throught the TIOT picking up the DDNAMEs       00668000
*     DSNAME.                                                           00669000
*                                                                       00670000
         L     R15,PSATOLD             Get A(TCB)                       00671000
         USING TCB,R15                 Establish addressability         00672000
         L     R15,TCBTIO              Get A(TIOT)                      00673000
         USING TIOTDS,R15              Establish addressability         00674000
         LA    R2,TIOENTRY             Point to first entry             00675000
         USING TIOENTRY,R2             Establish addressability         00676000
         SR    R7,R7                   Clear target registers           00677000
         SPACE 1                                                        00678000
STIOLP02 EQU   *                                                        00679000
         ICM   R7,B'0001',TIOELNGH     Pick up entry length             00680000
         BZ    SCAN2END                If end-of-TIOT, not found        00681000
         TM    TIOELINK,TIOSYOUT+TIOTTERM+TIOEDYNM+TIOEQNAM+TIOESYIN+TIX00682000
               OESYOT+TIOESSDS+TIOTREM Ensure no non-DASD flags set     00683000
         BNZ   STIONX02                                                 00684000
         CLI   TIOEDDNM,0              Dead entry ?                     00685000
         BE    STIONX02                If so, ignore it                 00686000
         CLI   TIOEDDNM,C' '           Concatenation ?                  00687000
         BE    STIONX02                If so, RDJFCB won't find it      00688000
         CLC   TIOEDDNM,WKRKEY         Is this the one?                 00689000
         BNE   STIONX02                No                               00690000
         $ICALL BUILDMVS               Good one found, go add it        00691000
STIONX02 EQU   *                                                        00692000
         AR    R2,R7                   Bump to next entry               00693000
         B     STIOLP02                 and loop till done              00694000
         SPACE ,                                                        00695000
SCAN2END DS    0H                      Return to caller                 00696000
         SPACE ,                                                        00697000
RKEY_MASTER_END     DS  0H                                              00698000
         ICM   R3,15,WKCURFID          -> current record                00699000
         BZ    RKEYEOF                 If none, then EOF                00700000
         L     R4,WKBUFADR             -> buffer                        00701000
         L     R15,BUFFAD              -> where to store it             00702000
         ST    R4,0(,R15)              Save                             00703000
         L     R14,=A(FD_MDATAL)      Get length                        00704000
         L     R15,BUFLEN              -> where to store it             00705000
         ST    R14,0(,R15)             Save                             00706000
         MVC   0(FD_MDATAL,R4),0(R3)  Move the data to work buffer      00707000
         SR    R15,R15                 Set RC to zero                   00708000
         B     RKEYRTRN                And return                       00709000
         SPACE ,                                                        00710000
RKEYRTRN      DS   0H                                                   00711000
         L     R14,RC                                                   00712000
         ST    R15,0(,R14)                                              00713000
         L     R13,4(,R13)             Get caller's savearea            00714000
         LM    R14,R12,12(R13)         Restore his registers            00715000
         BR    R14                     Return                           00716000
         SPACE ,                                                        00717000
RKEYEOF       DS   0H                  None found                       00718000
         L     R15,=F'4'               EOF error                        00719000
         B     RKEYRTRN                And return                       00720000
         SPACE ,                                                        00721000
RKEYERR  DS    0H                      return an i/o error              00722000
         L     R15,=F'8'                                                00723000
         B     RKEYRTRN                And return                       00724000
         SPACE 3                                                        00725000
         DROP  R2,R15                                                   00726000
         LTORG                                                          00727000
         EJECT                                                          00728000
*********************************************************************** 00729000
*                                                                     * 00730000
*             A L L   S U B R O U T I N E S   F O L L O W             * 00731000
*                                                                     * 00732000
*********************************************************************** 00733000
         SPACE 3                                                        00734000
*********************************************************************** 00735000
*                                                                     * 00736000
*                          D E L L E V E L                            * 00737000
*                                                                     * 00738000
*********************************************************************** 00739000
         SPACE 3                                                        00740000
DELLEVEL DS    0H                                                       00741000
*                                                                       00742000
*     This subroutine unchains and deletes the current level entry.     00743000
*                                                                       00744000
         STM   R0,R15,WKSAVE02         Save caller's registers          00745000
         LR    R11,R15                 Set up base                      00746000
         USING DELLEVEL,R11                                             00747000
         SPACE 1                                                        00748000
         L     R1,WKSEGSUB             -> anchor                        00749000
         SPACE ,                                                        00750000
DELL_NEXT     DS    0H                                                  00751000
         L     R2,0(,R1)               -> next                          00752000
         FREEMAIN RU,LV=4096,A=(1),SP=127   Get rid of this one         00753000
         LTR   R1,R2                   Is there another?                00754000
         BNZ   DELL_NEXT               Yes, go get rid of it            00755000
         SPACE ,                                                        00756000
         XC    WKFIDSUB,WKFIDSUB       Clear anchor                     00757000
         XC    WKSEGSUB,WKSEGSUB       And storage anchor               00758000
         SPACE ,                                                        00759000
         XC    WK1FID,WK1FID           Clear the pointers               00760000
         XC    WKCURFID,WKCURFID       and this                         00761000
         XC    WKCURSEG,WKCURSEG                                        00762000
         XC    WKXFIDBF,WKXFIDBF                                        00763000
         XC    WKXDATBF,WKXDATBF                                        00764000
         XC    WKRKEY,WKRKEY           Also clear last RKEY value       00765000
DLVLRTRN DS    0H                                                       00766000
         LM    R0,R14,WKSAVE02         Restore registers                00767000
         SR    R15,R15                 Set return code                  00768000
         BR    R14                     Return to caller                 00769000
         SPACE 3                                                        00770000
         LTORG                                                          00771000
         EJECT                                                          00772000
*********************************************************************** 00773000
*********************************************************************** 00774000
*                                                                     * 00775000
*                          G E T R E C R D                            * 00776000
*                                                                     * 00777000
*********************************************************************** 00778000
*********************************************************************** 00779000
         SPACE 3                                                        00780000
GETRECRD DS    0H                                                       00781000
*                                                                       00782000
*     This subroutine gets the "next" record to be                      00783000
*     returned to NOMAD.                                                00784000
*                                                                       00785000
         SPACE ,                                                        00786000
         STM   R0,R15,WKSAVE02         Save the registers               00787000
         LR    R11,R15                                                  00788000
         USING GETRECRD,R11            Define base                      00789000
         ICM   R1,15,WKCURFID          -> current fid                   00790000
         BZ    GREC_FIRST              Oops, none                       00791000
         USING FILE_DEF,R1                                              00792000
         ICM   R1,15,FD_NADDR         -> Next                           00793000
         BZ    GRECEOF                 None                             00794000
         ST    R1,WKCURFID                                              00795000
         B     GRECGREC                                                 00796000
         DROP  R1                                                       00797000
         EJECT ,                                                        00798000
*                                                                       00799000
*  We need to initialize the data.  It may be a FIRST or just a         00800000
*  refresh for some reason.                                             00801000
*                                                                       00802000
GREC_FIRST    DS    0H                                                  00803000
*********************************************************************** 00804000
*                                                                     * 00805000
*                      S C A N   T H E   T I O T                      * 00806000
*                                                                     * 00807000
*********************************************************************** 00808000
         USING PSA,R0                                                   00809000
         SPACE ,                                                        00810000
SCANTIOT EQU   *                                                        00811000
*                                                                       00812000
*     This section scans throught the TIOT picking up the DDNAMEs       00813000
*                                                                       00814000
         L     R15,PSATOLD             Get A(TCB)                       00815000
         USING TCB,R15                 Establish addressability         00816000
         L     R15,TCBTIO              Get A(TIOT)                      00817000
         USING TIOTDS,R15              Establish addressability         00818000
         LA    R2,TIOENTRY             Point to first entry             00819000
         USING TIOENTRY,R2             Establish addressability         00820000
         SR    R7,R7                   Clear target registers           00821000
         SPACE 1                                                        00822000
STIOLP01 EQU   *                                                        00823000
         ICM   R7,B'0001',TIOELNGH     Pick up entry length             00824000
         BZ    SCANRTRN                If end-of-TIOT, not found        00825000
         TM    TIOELINK,TIOSYOUT+TIOTTERM+TIOEDYNM+TIOEQNAM+TIOESYIN+TIX00826000
               OESYOT+TIOESSDS+TIOTREM Ensure no non-DASD flags set     00827000
         BNZ   STIONX01                                                 00828000
         CLI   TIOEDDNM,0              Dead entry ?                     00829000
         BE    STIONX01                If so, ignore it                 00830000
         CLI   TIOEDDNM,C' '           Concatenation ?                  00831000
         BE    STIONX01                If so, RDJFCB won't find it      00832000
         $ICALL BUILDMVS               Good one found, go add it        00833000
STIONX01 EQU   *                                                        00834000
         AR    R2,R7                   Bump to next entry               00835000
         B     STIOLP01                 and loop till done              00836000
         SPACE ,                                                        00837000
SCANRTRN DS    0H                      Return to caller                 00838000
         SPACE ,                                                        00839000
GREC_END_FIRST    DS    0H                                              00840000
         L     R1,WK1FID               Make the first one current       00841000
         ST    R1,WKCURFID                                              00842000
         B     GRECGREC                                                 00843000
         SPACE 1                                                        00844000
GRECGREC DS    0H                                                       00845000
         LM    R0,R14,WKSAVE02         Restore registers                00846000
         SR    R15,R15                 Set return code                  00847000
         BR    R14                     Return to caller                 00848000
         SPACE 1                                                        00849000
GRECEOF  DS    0H                                                       00850000
         LM    R0,R14,WKSAVE02         Restore registers                00851000
         LA    R15,4                   Set return code                  00852000
         BR    R14                     Return to caller                 00853000
         SPACE 3                                                        00854000
         LTORG                                                          00855000
         EJECT                                                          00856000
*********************************************************************** 00857000
*********************************************************************** 00858000
*                                                                     * 00859000
*                          G E T B O T H                              * 00860000
*                                                                     * 00861000
*********************************************************************** 00862000
*********************************************************************** 00863000
         SPACE 3                                                        00864000
GETBOTH  DS    0H                                                       00865000
*                                                                       00866000
*     This subroutine gets and initializes the storage for a MASTER     00867000
*                                                                       00868000
         SPACE ,                                                        00869000
         STM   R0,R15,WKSAVE05         Save the registers               00870000
         LR    R11,R15                                                  00871000
         USING GETBOTH,R11             Define base                      00872000
*                                                                       00873000
*   Go get a data buffer.  This routine also initializes most of        00874000
*   the data to &NAV and initializes the next pointers.                 00875000
*   The routine is $ICALLed.                                            00876000
*   Upon exit, R3 -> new data buffer                                    00877000
*                                                                       00878000
         L     R0,=A(FD_MLEN)                                           00879000
         ICM   R4,15,WKSEGSUB          -> anchor                        00880000
         BNZ   GB_FIND_SPACE           We have the first block          00881000
         LA    R4,WKSEGSUB             else -> where to save first      00882000
         B     GB_GET_SPACE                                             00883000
         SPACE ,                                                        00884000
*                                                                       00885000
*  Find some space to put this record.  If all blocks are full, get     00886000
*  another 4K and chain it in.                                          00887000
*                                                                       00888000
GB_FIND_SPACE DS    0H                                                  00889000
         L     R7,4(,R4)               Get count                        00890000
         C     R7,=A(DBUFMAX)          Have we reached max?             00891000
         BL    GB_NEXT                 No                               00892000
         LR    R5,R4                   Save this one                    00893000
         ICM   R4,15,0(R4)             Is there a next?                 00894000
         BNZ   GB_FIND_SPACE           Yes, try it                      00895000
         LR    R4,R5                   No, restore last                 00896000
         SPACE ,                                                        00897000
GB_GET_SPACE  DS    0H                                                  00898000
         L     R0,=F'4096'             Yes, get another                 00899000
         GETMAIN RU,LV=(0),SP=127,LOC=ANY   Get storage                 00900000
         ST    R1,0(,R4)               Save address                     00901000
         LR    R4,R1                   -> block                         00902000
         XC    0(8,R4),0(R4)           Clear storage area               00903000
         SR    R7,R7                   Start with zero                  00904000
         SPACE ,                                                        00905000
GB_NEXT  DS    0H                                                       00906000
         LR    R15,R7                  Get count                        00907000
         M     R14,=A(FD_MLEN)         times count                      00908000
         LA    R3,8(R15,R4)            -> next block                    00909000
         A     R7,=F'1'                Increment count                  00910000
         ST    R7,4(,R4)               And save back                    00911000
         ST    R3,WKCURFID             This is current block            00912000
         USING FILE_DEF,R3                                              00913000
*                                                                       00914000
*  Initialize the records.                                              00915000
*                                                                       00916000
         XC    0(FD_MLEN,R3),0(R3)     Clear block                      00917000
         L     R1,WKSAVE05+4*R1        Restore caller's R1              00918000
         MVC   FD_DDNAME,0(R1)         Move in ddname                   00919000
         LA    R14,WK1FID              -> to where to store             00920000
         ICM   R1,15,WK1FID            is this the first?               00921000
         BNZ   GETB_SFREE_1            No, go find right spot           00922000
         ST    R3,WK1FID               Yes, save it                     00923000
         B     GETB_SFREE_9            Now go init dependent            00924000
         SPACE ,                                                        00925000
GETB_SFREE_1  DS   0H                                                   00926000
         CLC   FD_DDNAME,FD_DDNAME-FILE_DEF(R1)                         00927000
         BE    GETB_OLD                                                 00928000
         BL    GETB_LOW                                                 00929000
         LA    R14,FD_NADDR-FILE_DEF(,R1)    -> where to store          00930000
         ICM   R1,15,FD_NADDR-FILE_DEF(R1)   Get next                   00931000
         BNZ   GETB_SFREE_1                   And loop                  00932000
         SPACE ,                                                        00933000
GETB_LOW      DS   0H                                                   00934000
         ST    R3,0(,R14)              Chain this                       00935000
         ST    R1,FD_NADDR            And the next                      00936000
         B     GETB_SFREE_9                                             00937000
         SPACE ,                                                        00938000
GETB_OLD      DS   0H                                                   00939000
         LR    R3,R1                   Ignore new one                   00940000
         ST    R1,WKCURFID                                              00941000
         SPACE ,                                                        00942000
GETB_SFREE_9  DS   0H                                                   00943000
*                                                                       00944000
*  Now initialize the segment.                                          00945000
*                                                                       00946000
         MVI   FD_DEVTYPE,GLOBNAV     Init to NAV                       00947000
         MVI   FD_DEVTYPE+1,X'00'                                       00948000
         MVI   FD_DSNAME,GLOBNAV      Clear dataset name                00949000
         MVC   FD_DSNAME+1,=43X'00'   to NAV                            00950000
         MVC   FD_MEMBER,FD_DSNAME   This to NAV also                   00951000
         MVC   FD_MVS_DISP,FD_DSNAME     disposition                    00952000
         MVC   FD_RECFM,FD_DSNAME        RECFM                          00953000
         MVC   FD_LRECL,FD_DSNAME        LRECL                          00954000
         MVC   FD_BLKSIZE,FD_DSNAME      BLKSIZE                        00955000
         MVC   FD_BUFNO,FD_DSNAME        BUFNO                          00956000
         ST    R3,WKSAVE05+(R3*4)      Save the ->                      00957000
         LM    R0,R14,WKSAVE05         Restore registers                00958000
         SR    R15,R15                 Set return code                  00959000
         BR    R14                     Return to caller                 00960000
         DROP  R3                                                       00961000
         SPACE 3                                                        00962000
         LTORG                                                          00963000
         EJECT                                                          00964000
BUILDMVS DS    0H                                                       00965000
         STM   R0,R14,WKSAVE04         Save my registers                00966000
         LR    R11,R15                                                  00967000
         USING BUILDMVS,R11            Define the base                  00968000
         USING TIOENTRY,R2             Set when we are entered          00969000
         USING FILE_DEF,R3             Define the base                  00970000
         SPACE ,                                                        00971000
*                                                                       00972000
*  Build MASTER record.                                                 00973000
*                                                                       00974000
BMVS_NONE      DS   0H                                                  00975000
         LA    R1,TIOEDDNM             -> current file-id               00976000
         $ICALL GETBOTH                Go get a buffer                  00977000
         MVC   FD_DDNAME(L'TIOEDDNM),TIOEDDNM                           00978000
*                                                                       00979000
*  Initialize some ALLOC record stuff.                                  00980000
*                                                                       00981000
         XC    FD_MVS_DISP,FD_MVS_DISP                                  00982000
         MVI   FD_MVS_DISP,GLOBNAV                                      00983000
         XC    FD_SPACE_HOW,FD_SPACE_HOW                                00984000
         MVI   FD_SPACE_HOW,GLOBNAV                                     00985000
         XC    FD_VOLSER,FD_VOLSER          First volser                00986000
         MVI   FD_VOLSER,GLOBNAV                                        00987000
         MVC   FD_VOLSER+L'FD_VOLSER(4*L'FD_VOLSER),FD_VOLSER           00988000
         XC    FD_UNIT,FD_UNIT                                          00989000
         MVI   FD_UNIT,GLOBNAV                                          00990000
         L     R15,=A(DCB)             Move in skeleton DCB             00991000
         MVC   JFWKDCB(DCBL),0(R15)                                     00992000
         LA    R4,JFWKDCB              Get DCB address                  00993000
         USING IHADCB,R4               Establish addressability         00994000
         LA    R5,JFWKJFCB             Get JFCB address                 00995000
         ST    R5,JFWKXLST             Set up EXLST                     00996000
         MVI   JFWKXLST,B'10000111'                                     00997000
         LA    R0,JFWKXLST             Store EXLST address in DCB       00998000
         STCM  R0,B'0111',DCBEXLSA                                      00999000
         L     R15,=A(RDJFCB)          Move RDJFCB PLIST to area        01000000
         MVC   JFWKPLST(RDJFCBL),0(R15)                                 01001000
RDJGAREA EQU   *                                                        01002000
         LA    R4,JFWKDCB              Get DCB address                  01003000
         MVC   DCBDDNAM,FD_DDNAME      Supply DDNAME                    01004000
         RDJFCB ((R4)),                Read the JFCB                   X01005000
               MF=(E,JFWKPLST)                                          01006000
         LTR   R15,R15                 Check return code                01007000
         BNZ   BMVS_JOIN               If error, return                 01008000
         LA    R7,JFWKJFCB             -> data area                     01009000
         USING JFCBDS,R7               Define base                      01010000
         TM    TIOELINK,TIOSYOUT+TIOTTERM+TIOEDYNM+TIOEQNAM+TIOESYIN+TIX01011000
               OESYOT+TIOESSDS+TIOTREM Ensure no non-DASD flags set     01012000
         BNZ   BMVS_SEG2B                                               01013000
         MVC   FD_DSNAME,JFCBDSNM     Get dataset name                  01014000
         TM    JFCBIND1,JFCPDS+JFCGDG    Is it PDS or GDG?              01015000
         BZ    BMVS_SEG2C              No                               01016000
         MVC   FD_MEMBER,JFCBELNM     Yes, move in member               01017000
         B     BMVS_SEG2C                                               01018000
         SPACE ,                                                        01019000
BMVS_SEG2B     DS   0H                                                  01020000
*        CLI   JFCDEV,JFCTAP     Is this a tape?                        01021000
*        BNE   BMVS_SEG2C                                               01022000
         SPACE ,                                                        01023000
BMVS_SEG2C     DS   0H                                                  01024000
         CLC   JFCLRECL,=F'0'       Is there an LRECL?                  01025000
         BE    BMVS_BLKSIZE             No                              01026000
         MVC   FD_LRECL(2),JFCLRECL    Get data                         01027000
         SPACE ,                                                        01028000
BMVS_BLKSIZE   DS   0H                                                  01029000
         CLC   JFCBLKSI,=F'0'       Is there a BLKSIZE?                 01030000
         BE    BMVS_BUFNO               No                              01031000
         MVC   FD_BLKSIZE(2),JFCBLKSI      Get data                     01032000
         SPACE ,                                                        01033000
BMVS_BUFNO    DS    0H                                                  01034000
         CLI   JFCBUFNO,0           Is there a BLKSIZE?                 01035000
         BE    BMVS_RECFM               No                              01036000
         MVC   FD_BUFNO+1,JFCBUFNO      Get data                        01037000
         MVI   FD_BUFNO,0               And set top byte                01038000
         SPACE ,                                                        01039000
BMVS_RECFM    DS    0H                                                  01040000
         TM   JFCRECFM,DCBRECU      Is RECFM undefined?                 01041000
         BNO  BMVS_RECFM2               No                              01042000
         MVC  FD_RECFM,=CL4'V'        We say variable                   01043000
         B    BMVS_RECFM_B              Now go check blocking           01044000
         SPACE ,                                                        01045000
BMVS_RECFM2   DS    0H                                                  01046000
         TM   JFCRECFM,DCBRECF      Is RECFM fixed?                     01047000
         BNO  BMVS_RECFM3               No                              01048000
         MVC  FD_RECFM,=CL4'F'        Make it so                        01049000
         B    BMVS_RECFM_B              Now go check blocking           01050000
         SPACE ,                                                        01051000
BMVS_RECFM3   DS    0H                                                  01052000
         TM   JFCRECFM,DCBRECV      Is RECFM variable?                  01053000
         BNO  BMVS_RECFM9               No                              01054000
         MVC  FD_RECFM,=CL4'I'        Make it so                        01055000
         TM   JFCRECFM,DCBRECSB     Is it spanned?                      01056000
         BNO  BMVS_RECFM_B              No go check blocked             01057000
         MVI  FD_RECFM+3,C'S'         Yes, make it so                   01058000
         B    BMVS_RECFM_B              Now go check blocking           01059000
         SPACE ,                                                        01060000
BMVS_RECFM_B  DS    0H                  Check for blocking              01061000
         TM   JFCRECFM,DCBRECBR     Are records blocked?                01062000
         BNO  BMVS_RECFM_CC             No                              01063000
         MVI  FD_RECFM+1,C'B'         Yes, set it                       01064000
         SPACE ,                                                        01065000
BMVS_RECFM_CC DS    0H                  Check for carriage control      01066000
         TM   JFCRECFM,DCBRECCA     is CC ASA on?                       01067000
         BNO  BMVS_RECFM_CC2            No                              01068000
         MVI  FD_RECFM+2,C'A'         Yes, set it                       01069000
         B    BMVS_RECFM9                                               01070000
         SPACE ,                                                        01071000
BMVS_RECFM_CC2   DS    0H               Check for carriage control      01072000
         TM   JFCRECFM,DCBRECCM     is CC machine on?                   01073000
         BNO  BMVS_RECFM9               No                              01074000
         MVI  FD_RECFM+2,C'M'         Yes, set it                       01075000
         B    BMVS_RECFM9                                               01076000
         SPACE ,                                                        01077000
BMVS_RECFM9   DS    0H                                                  01078000
         TM    JFCBIND2,JFCNEW         Is there any disposition?        01079000
         BZ    BMVS_DEVTYPE            Nope                             01080000
         BNO   BMVS_DISP2              Well, its not NEW                01081000
         MVC   FD_MVS_DISP,=C'NEW'    Move in literal                   01082000
         B     BMVS_DEVTYPE            And rejoin                       01083000
         SPACE ,                                                        01084000
BMVS_DISP2    DS    0H                                                  01085000
         TM    JFCBIND2,JFCMOD         Is DISP=MOD?                     01086000
         BNO   BMVS_DISP3              Nope                             01087000
         MVC   FD_MVS_DISP,=C'MOD'    Move in literal                   01088000
         B     BMVS_DEVTYPE            And rejoin                       01089000
         SPACE ,                                                        01090000
BMVS_DISP3    DS    0H                                                  01091000
         TM    JFCBIND2,JFCOLD         Is DISP=OLD?                     01092000
         BNO   BMVS_DISP4              Nope                             01093000
         MVC   FD_MVS_DISP,=C'OLD'    Move in literal                   01094000
         B     BMVS_DEVTYPE            And rejoin                       01095000
         SPACE ,                                                        01096000
BMVS_DISP4    DS    0H                                                  01097000
         TM    JFCBIND2,JFCSHARE       Is DISP=SHR?                     01098000
         BNO   BMVS_DISP5              Nope                             01099000
         MVC   FD_MVS_DISP,=C'SHR'    Move in literal                   01100000
         B     BMVS_DEVTYPE            And rejoin                       01101000
         SPACE ,                                                        01102000
BMVS_DISP5    DS    0H                                                  01103000
         SPACE ,                                                        01104000
BMVS_DEVTYPE  DS    0H                                                  01105000
         TM    TIOELINK,TIOSYOUT+TIOTTERM+TIOEDYNM+TIOEQNAM+TIOESYIN+TIX01106000
               OESYOT+TIOESSDS+TIOTREM Ensure no non-DASD flags set     01107000
         BZ    BMVS_DISK                                                01108000
         TM    TIOELINK,TIOTTERM        Is it a terminal?               01109000
         BO    BMVS_TERM                                                01110000
         TM    TIOELINK,TIOESYIN        How about spooled input?        01111000
         BO    BMVS_READER                                              01112000
         TM    TIOELINK,TIOESYOT        Or spooled output?              01113000
         BO    BMVS_PRINTER                                             01114000
         B     BMVS_DUMMY                                               01115000
         B     BMVS_TAPE                                                01116000
         B     BMVS_PUNCH                                               01117000
         B     BMVS_CRT                                                 01118000
         SPACE ,                                                        01119000
BMVS_DISK      DS    0H                 Device type = disk              01120000
         TM    JFCDSRG2,JFCORGAM        Is it VSAM?                     01121000
         BO    BMVS_VSAM                Yes                             01122000
         BAL   R14,BMVS_VOLSER          Go get VOLSER                   01123000
         TM    JFCDSORG,JFCORGPO        How about a PDS?                01124000
         BO    BMVS_PDS                 Yes                             01125000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_DI)                           01126000
         B     BMVS_JOIN                                                01127000
         SPACE ,                                                        01128000
BMVS_VSAM      DS    0H                 Device type = VSAM              01129000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_VS)      Set it               01130000
         B     BMVS_JOIN                                                01131000
         SPACE ,                                                        01132000
BMVS_PDS       DS    0H                 Device type = PDS               01133000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_PO)      Set it               01134000
         B     BMVS_JOIN                                                01135000
         SPACE ,                                                        01136000
BMVS_TAPE      DS    0H                 Device type = tape              01137000
         BAL   R14,BMVS_VOLSER          Go get VOLSER                   01138000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_TA)      Set it               01139000
         B     BMVS_JOIN                                                01140000
         SPACE ,                                                        01141000
BMVS_DUMMY     DS    0H                 Device type = DUMMY             01142000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_OT)      Set it               01143000
         B     BMVS_JOIN                                                01144000
         SPACE ,                                                        01145000
BMVS_PRINTER   DS    0H                 Device type = printer           01146000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_PT)      Set it               01147000
         B     BMVS_JOIN                                                01148000
         SPACE ,                                                        01149000
BMVS_PUNCH     DS    0H                 Device type = punch             01150000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_SY)      Set it               01151000
         B     BMVS_JOIN                                                01152000
         SPACE ,                                                        01153000
BMVS_READER    DS    0H                 Device type = reader            01154000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_OT)      Set it               01155000
         B     BMVS_JOIN                                                01156000
         SPACE ,                                                        01157000
BMVS_TERM      DS    0H                 Device type = terminal          01158000
         SPACE ,                                                        01159000
BMVS_CRT       DS    0H                 Device type = CRT               01160000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_TE)      Set terminal         01161000
         B     BMVS_JOIN                                                01162000
         SPACE ,                                                        01163000
BMVS_VOLSER   DS    0H                                                  01164000
         CLI   JFCBNVOL,X'00'          Are there any VOL SERs?          01165000
         BER   R14                     No                               01166000
         LA    R1,JFCBVOLS             Yes -> first one                 01167000
         LA    R6,FD_VOLSER           and in MASTER                     01168000
         SR    R15,R15                                                  01169000
         ICM   R15,1,JFCBNVOL          Get count                        01170000
         SPACE ,                                                        01171000
BMVS_VOLSER_LP   DS    0H                                               01172000
         MVC   0(L'FD_VOLSER,R6),0(R1)   Move in VOLSER                 01173000
         LA    R6,L'FD_VOLSER(,R6)    Increment                         01174000
         LA    R1,6(,R1)               And source                       01175000
         BCT   R15,BMVS_VOLSER_LP      Any more?                        01176000
         BR    R14                     Return to caller                 01177000
         SPACE ,                                                        01178000
BMVS_JOIN      DS    0H                Done with device types           01179000
         SPACE ,                                                        01180000
BMVS_END       DS    0H                Done!  Let's exit                01181000
         LM    R0,R14,WKSAVE04         Restore registers                01182000
         SR    R15,R15                 Set return code                  01183000
         BR    R14                     Return to caller                 01184000
         SPACE 3                                                        01185000
         DROP  R2,R3,R7                                                 01186000
         SPACE 3                                                        01187000
         LTORG                                                          01188000
         EJECT                                                          01189000
*********************************************************************** 01190000
*********************************************************************** 01191000
*                                                                     * 01192000
*                         C O N S T A N T S                           * 01193000
*                                                                     * 01194000
*********************************************************************** 01195000
*********************************************************************** 01196000
         SPACE 3                                                        01197000
OPCTABLE DC    A(0,OPEN,CLOSE,SHUTDOWN,FIRST,NEXT,0,0,0,RKEY,0,0,LAST,PX01198000
               REVIOUS)                                                 01199000
         SPACE 3                                                        01200000
         DS    0F                                                       01201000
DCB      DCB   DSORG=PS,MACRF=GL,DDNAME=X,EXLST=*                       01202000
DCBL     EQU   *-DCB                                                    01203000
RDJFCB   RDJFCB (*),MF=L                                                01204000
RDJFCBL  EQU   *-RDJFCB                                                 01205000
         END                                                            01206000
