UXACC0   CSECT ,                                                        00001000
UXACC0   TITLE 'FILEDEF GEDI Routine'                                   00002000
*                                                                       00003000
*  This routine requires the DMSGPI, DMSOM, OSMACRO, OSMACRO1 MACLIBS.  00004000
*  It was compiled by Thomson Software Products using the               00005000
*  High Level Assembler. The H-level assembler should work also.        00006000
*                                                                       00007000
         REGEQU                                                         00008000
GLOBNAV  EQU   X'80'        Global NAV value                            00009000
         MACRO                                                          00010000
&LAB     $ICALL &WHERE,&BASE=R15,&RET=R14                               00011000
.*   $ICALL ABC         --> L    R15,=A(ABC)                            00012000
.*                          BALR R14,R15                                00013000
.*                                                                      00014000
.*   $ICALL ABC,RET=R9  --> L    R15,=A(ABC)                            00015000
.*                          BALR R9,R15                                 00016000
.*                                                                      00017000
.*   $ICALL ABC,RET=R8  --> L    R15,=A(ABC)                            00018000
.*                          BALR R8,R15                                 00019000
.*                                                                      00020000
         LCLC  &LABL                                                    00021000
&LABL    SETC  '&LAB'                                                   00022000
         AIF   ('&WHERE' EQ '('.'&WHERE(1)'.')').LR                     00023000
&LABL    ICM   &BASE,15,=A(&WHERE)                                      00024000
&LABL    SETC  ''                                                       00025000
         AGO   .COM                                                     00026000
.LR      ANOP ,                                                         00027000
         AIF   ('&WHERE(1)' EQ '15').COM                                00028000
         AIF   ('&WHERE(1)' EQ 'R15').COM                               00029000
         AIF   ('&BASE' EQ '&WHERE(1)').COM                             00030000
&LABL    LR    &BASE,&WHERE(1)                                          00031000
&LABL    SETC  ''                                                       00032000
.COM     AIF   ('&RET' EQ '').BALR14                                    00033000
&LABL    BALR  &RET,&BASE                                               00034000
         MEXIT                                                          00035000
.BALR14  ANOP  ,                                                        00036000
         MNOTE 2,'RET= is not specified, set to R14'                    00037000
&LABL    BALR  R14,&BASE                                                00038000
         MEND                                                           00039000
         PRINT NOGEN                                                    00040000
UXACC0   AMODE 31                                                       00041000
UXACC0   RMODE ANY                                                      00042000
         EJECT ,                                                        00043000
*********************************************************************** 00044000
*********************************************************************** 00045000
*                                                                     * 00046000
*                             D S E C T S                             * 00047000
*                                                                     * 00048000
*********************************************************************** 00049000
*********************************************************************** 00050000
         PRINT NOGEN                                                    00051000
         SPACE 3                                                        00052000
         DCBD  DSORG=PS                                                 00053000
         SPACE 3                                                        00054000
         PRINT GEN,MSOURCE                                              00055000
*                                                                       00056000
*  This is the assembler description of the record to be returned to    00057000
*  NOMAD.  It needs to agree in detail (including length) with the      00058000
*  SCHEMA.                                                              00059000
*                                                                       00060000
FILE_DEF     DSECT ,     FILE_DEF MASTER Record description             00061000
FD_DDNAME    DS   CL8    DDNAME                                         00062000
         SPACE ,                                                        00063000
FD_DEVTYPE   DS   CL2    Device type:                                   00064000
FD_DEVTYPE_DI EQU  C'DI'  Disk                                          00065000
FD_DEVTYPE_TA EQU  C'TA'  Tape                                          00066000
FD_DEVTYPE_TE EQU  C'TE'  Terminal                                      00067000
FD_DEVTYPE_PT EQU  C'PT'  Printer                                       00068000
FD_DEVTYPE_OT EQU  C'OT'  Other                                         00069000
FD_DEVTYPE_SY EQU  C'SY'  SYSOUT                                        00070000
FD_DEVTYPE_VS EQU  C'VS'  VSAM                                          00071000
         SPACE ,                                                        00072000
FD_FILENAME  DS   CL8    VM filename                                    00073000
FD_FILETYPE  DS   CL8    VM filetype                                    00074000
FD_FILEMODE  DS   CL2    VM filemode (if accessed)                      00075000
         SPACE ,                                                        00076000
FD_RECFM     DS   CL4    RECFM                                          00077000
FD_LRECL     DS   F      LRECL                                          00078000
FD_BLKSIZE   DS   F      BLKSIZE                                        00079000
FD_MDATAL     EQU  *-FD_DDNAME    Actual length of data                 00080000
         SPACE ,                                                        00081000
             DS   0D                                                    00082000
FD_NADDR     DS   F      -> next MASTER                                 00083000
FD_MLEN       EQU  *-FD_DDNAME    Actual length of data                 00084000
         SPACE 3                                                        00085000
*********************************************************************** 00086000
*                                                                     * 00087000
*             G E D I   U S E R   E X I T   R O U T I N E             * 00088000
*                                                                     * 00089000
*                           P A R M L I S T                           * 00090000
*                                                                     * 00091000
*********************************************************************** 00092000
         SPACE 3                                                        00093000
GEDIPARM DSECT                                                          00094000
         SPACE 2                                                        00095000
SEGNAM   DS    A                                                        00096000
OPCODE   DS    A                                                        00097000
RC       DS    A                                                        00098000
BUFFAD   DS    A                                                        00099000
BUFLEN   DS    A                                                        00100000
KEYBUF   DS    A                                                        00101000
KEYLEN   DS    A                                                        00102000
INFO     DS    A                                                        00103000
INFLEN   DS    A                                                        00104000
SORTFL   DS    A                                                        00105000
N2VERN   DS    A                                                        00106000
USVERN   DS    A                                                        00107000
USWD     DS    A                                                        00108000
DBNAME   DS    A                                                        00109000
PARENT   DS    A                                                        00110000
IBUFAD   DS    A                                                        00111000
IBUFLN   DS    A                                                        00112000
PREVFL   DS    A                                                        00113000
LASTFL   DS    A                                                        00114000
N2WRIT   DS    A                                                        00115000
USWRIT   DS    A                                                        00116000
         SPACE 3                                                        00117000
GEDIPLEN EQU   *-GEDIPARM              Length of parmlist               00118000
         EJECT                                                          00119000
         PRINT ON,GEN                                                   00120000
         CMSCB                                                          00121000
         EJECT                                                          00122000
         NUCON                                                          00123000
         EJECT                                                          00124000
*********************************************************************** 00125000
*                                                                     * 00126000
*                     L O C A L   W O R K A R E A                     * 00127000
*                                                                     * 00128000
*********************************************************************** 00129000
         SPACE 3                                                        00130000
WKAREADS DSECT                                                          00131000
         SPACE 1                                                        00132000
         DS    18F                     OS Savearea                      00133000
         SPACE 1                                                        00134000
WKDBLWD  DS    D                       Doubleword workarea              00135000
WKBUFADR DS    A                       A(Buffer)                        00136000
WKBUFLEN DS    F                       Buffer length                    00137000
WKFIDCNT DS    F                       FID  count                       00138000
WK1FID   DS    A                       -> First FID                     00139000
WKCURFID DS    A                       -> Current FID                   00140000
WKCURSEG DS    A                       -> data segment                  00141000
WKXFIDBF DS    A                       -> FID Instance Buffer           00142000
WKXDATBF DS    A                       -> data segment Instance Buffer  00143000
WKFIDSUB DS    A                       $FREE subpool anchor             00144000
WKSEGSUB DS    A                                                        00145000
WKRKEY   DS    CL8                     Last RKEY DDNAME                 00146000
         SPACE 1                                                        00147000
WKSAVE01 DS    18F                     Subroutine savearea              00148000
WKSAVE02 DS    18F                     Subroutine savearea              00149000
WKSAVE03 DS    18F                     Subroutine savearea              00150000
WKSAVE04 DS    18F                     Subroutine savearea              00151000
WKSAVE05 DS    18F                     Subroutine savearea              00152000
WKSAVE06 DS    18F                     Subroutine savearea              00153000
         SPACE 3                                                        00154000
         DS    0D                                                       00155000
WKAREALN EQU   *-WKAREADS              Workarea length                  00156000
         EJECT                                                          00157000
UXACC0   CSECT ,                                                        00158000
*                                                                       00159000
*********************************************************************** 00160000
*                                                                     * 00161000
*     This program functions as a GEDI User Exit Routine to map       * 00162000
*         FILEDEF information as a database.                          * 00163000
*                                                                     * 00164000
*     Multiple concurrent users are supported through the USWD        * 00165000
*     feature of GEDI, which allows us to maintain separate areas     * 00166000
*     for each user of the database.                                  * 00167000
*                                                                     * 00168000
*                                                                     * 00169000
*     This program is reentrant.                                      * 00170000
*                                                                     * 00171000
*********************************************************************** 00172000
*                                                                       00173000
         EJECT                                                          00174000
*********************************************************************** 00175000
*********************************************************************** 00176000
*                                                                     * 00177000
*                      P R O C E S S   N O T E S                      * 00178000
*                                                                     * 00179000
*********************************************************************** 00180000
*********************************************************************** 00181000
         EJECT                                                          00182000
*********************************************************************** 00183000
*********************************************************************** 00184000
*                                                                     * 00185000
*                      E N T R Y   L I N K A G E                      * 00186000
*                                                                     * 00187000
*********************************************************************** 00188000
*********************************************************************** 00189000
         SPACE 3                                                        00190000
         USING UXACC0,R15              Temporary addressability         00191000
         B     SAVEREGS                Branch around eyecatcher         00192000
         DC    CL8'ACC9VM'                                              00193000
         DC    CL8'&SYSDATE'                                            00194000
         DC    CL8'&SYSTIME'                                            00195000
SAVEREGS EQU   *                                                        00196000
         STM   R14,R12,12(R13)         Save caller's registers          00197000
         LR    R11,R15                 Set up our base register         00198000
         DROP  R15                     Was UXMVSCAT                     00199000
         USING UXACC0,R11              Establish addressability         00200000
         LR    R9,R1                   Get parmlist address             00201000
         USING GEDIPARM,R9             Establish addressability         00202000
         L     R3,USWD                                                  00203000
         LR    R4,R13                  Save incoming address            00204000
         ICM   R2,B'1111',0(R3)        Workarea already exist ?         00205000
         BNZ   GOTWKAR                 If so, use it                    00206000
         L     R0,=A((WKAREALN+FD_MLEN)/8)                              00207000
         CMSSTOR OBTAIN,DWORDS=(0),LOC=BELOW  get storage               00208000
         LR    R2,R1                   Save the address                 00209000
         USING WKAREADS,R2             Establish addressability         00210000
         ST    R2,0(,R3)               Save for future calls            00211000
         LA    R5,WKAREALN(,R2)        -> buffer                        00212000
         ST    R5,WKBUFADR             Save the ->                      00213000
         LA    R5,FD_MLEN                                               00214000
         ST    R5,WKBUFLEN                                              00215000
         SUBPOOL CREATE,NAME='FILE_DEF'                                 00216000
         DROP  R2                      Was WKAREADS                     00217000
GOTWKAR  EQU   *                                                        00218000
         ST    R2,8(,R4)               Chain the saveareas              00219000
         ST    R4,4(,R2)                                                00220000
         LR    R13,R2                  Get ours to R13                  00221000
         USING WKAREADS,R13            Establish addressability         00222000
         EJECT                                                          00223000
*********************************************************************** 00224000
*                                                                     * 00225000
*                 D E T E R M I N E   F U N C T I O N                 * 00226000
*                                                                     * 00227000
*********************************************************************** 00228000
         SPACE 3                                                        00229000
DETFUNC  DS    0H                                                       00230000
*                                                                       00231000
*     This section routes control based on the function code.           00232000
*                                                                       00233000
         L     R15,OPCODE              Get function code                00234000
         L     R15,0(,R15)                                              00235000
         SLL   R15,2                   Convert to fullword offset       00236000
         A     R15,=A(OPCTABLE)        Get routine slot address         00237000
         ICM   R15,B'1111',0(R15)      Get routine address              00238000
         BNZR  R15                     If it exists, use it             00239000
         LA    R15,12                   else, give RC 12                00240000
         L     R14,RC                                                   00241000
         ST    R15,0(,R14)                                              00242000
         L     R13,4(,R13)                                              00243000
         LM    R14,R12,12(R13)                                          00244000
         BR    R14                                                      00245000
         SPACE 3                                                        00246000
         LTORG                                                          00247000
         EJECT                                                          00248000
*********************************************************************** 00249000
*********************************************************************** 00250000
*                                                                     * 00251000
*                               O P E N                               * 00252000
*                                                                     * 00253000
*********************************************************************** 00254000
*********************************************************************** 00255000
         SPACE 3                                                        00256000
OPEN     DS    0H                                                       00257000
*                                                                       00258000
*     For OPEN, we don't need to do anything?                           00259000
*                                                                       00260000
         LR    R11,R15                 Set up base register             00261000
         USING OPEN,R11                Establish addressability         00262000
         L     R15,USWRIT              -> writable switch               00263000
         XC    0(4,R15),0(R15)         And set it off                   00264000
         L     R15,PREVFL              -> previousable switch           00265000
         XC    0(4,R15),0(R15)         And set it off                   00266000
         L     R15,LASTFL              -> lastable switch               00267000
         XC    0(4,R15),0(R15)         And set it off                   00268000
         SPACE ,                                                        00269000
OPENRTRN DS    0H                      Return to caller                 00270000
         SR    R15,R15                 Get an error                     00271000
         L     R14,RC                  Set return code                  00272000
         ST    R15,0(,R14)                                              00273000
         LA    R15,1                   Set SORTFL to 1                  00274000
         L     R14,SORTFL                                               00275000
         ST    R15,0(,R14)                                              00276000
         L     R14,USVERN              Set USVERN to 1                  00277000
         ST    R15,0(,R14)                                              00278000
         L     R13,4(,R13)             Restore caller's savearea        00279000
         LM    R14,R12,12(R13)         Restore his registers            00280000
         BR    R14                     Return                           00281000
         SPACE 3                                                        00282000
         LTORG                                                          00283000
         EJECT                                                          00284000
*********************************************************************** 00285000
*********************************************************************** 00286000
*                                                                     * 00287000
*                              C L O S E                              * 00288000
*                                                                     * 00289000
*********************************************************************** 00290000
*********************************************************************** 00291000
         SPACE 3                                                        00292000
CLOSE    DS    0H                                                       00293000
*                                                                       00294000
*     For CLOSE, we do nothing.                                         00295000
*                                                                       00296000
         LR    R11,R15                 Set up base register             00297000
         USING CLOSE,R11               Establish addressability         00298000
         SPACE ,                                                        00299000
CLOSRTRN DS    0H                      Return to caller                 00300000
         SR    R15,R15                 Set return code                  00301000
         L     R14,RC                                                   00302000
         ST    R15,0(,R14)                                              00303000
         L     R13,4(,R13)             Get caller's savearea            00304000
         LM    R14,R12,12(R13)         Restore his registers            00305000
         BR    R14                     Return                           00306000
         SPACE 3                                                        00307000
         LTORG                                                          00308000
         EJECT                                                          00309000
*********************************************************************** 00310000
*********************************************************************** 00311000
*                                                                     * 00312000
*                           S H U T D O W N                           * 00313000
*                                                                     * 00314000
*********************************************************************** 00315000
*********************************************************************** 00316000
         SPACE 3                                                        00317000
SHUTDOWN DS    0H                                                       00318000
*                                                                       00319000
*     For SHUTDOWN, we get rid of all storage.  This includes the data  00320000
*     buffers and our working storage.                                  00321000
*                                                                       00322000
         LR    R11,R15                 Set up base register             00323000
         USING SHUTDOWN,R11            Establish addressability         00324000
         SPACE 1                                                        00325000
         ICM   R1,15,WKFIDSUB          Do we have any storage?          00326000
         BZ    SHUT_RTRN               No                               00327000
         $ICALL DELLEVEL               YES, go delete all entries       00328000
         SPACE 1                                                        00329000
SHUT_RTRN    DS   0H                                                    00330000
         SUBPOOL DELETE,NAME='FILE_DEF'                                 00331000
         SR    R15,R15                 Set return code                  00332000
         L     R14,RC                                                   00333000
         ST    R15,0(,R14)                                              00334000
         L     R14,USWD                Clear workarea pointer           00335000
         ST    R15,0(,R14)                                              00336000
         LR    R1,R13                  Save workarea address            00337000
         L     R4,4(,R13)              Get caller's savearea            00338000
         L     R0,=A((WKAREALN+FD_MLEN)/8)                              00339000
         CMSSTOR RELEASE,DWORDS=(0),ADDR=(1)                            00340000
         DROP  R13                                                      00341000
         LR    R13,R4                                                   00342000
         LM    R14,R12,12(R13)         Restore his registers            00343000
         BR    R14                     Return                           00344000
         SPACE 3                                                        00345000
         LTORG                                                          00346000
         EJECT                                                          00347000
         USING WKAREADS,R13            Since we overrode this above     00348000
*********************************************************************** 00349000
*********************************************************************** 00350000
*                                                                     * 00351000
*                              F I R S T                              * 00352000
*                                                                     * 00353000
*********************************************************************** 00354000
*********************************************************************** 00355000
         SPACE 3                                                        00356000
FIRST    DS    0H                                                       00357000
*                                                                       00358000
*     For FIRST, we get rid of any existing data buffer.                00359000
*     We then call GETRECRD to get the next record.                     00360000
*                                                                       00361000
         LR    R11,R15                 Set up base register             00362000
         USING FIRST,R11               Establish addressability         00363000
         SPACE ,                                                        00364000
         ICM   R15,15,PARENT           Find out if FIRST MASTER         00365000
         BZ    FRSTERR                 Ooops, shouldn't be zero         00366000
         SPACE ,                                                        00367000
         ICM   R1,15,WKFIDSUB          Do we have any storage?          00368000
         BZ    FRST_START              No                               00369000
         $ICALL DELLEVEL               YES, go delete all entries       00370000
         SPACE ,                                                        00371000
FRST_START   DS    0H                                                   00372000
         XC    WK1FID,WK1FID           Clear the pointers               00373000
         XC    WKCURFID,WKCURFID       and this                         00374000
         XC    WKCURSEG,WKCURSEG                                        00375000
         XC    WKXFIDBF,WKXFIDBF                                        00376000
         XC    WKXDATBF,WKXDATBF                                        00377000
         XC    WKRKEY,WKRKEY                                            00378000
         SPACE ,                                                        00379000
         $ICALL GETRECRD                                                00380000
         LTR   R15,R15                 Is RC zero?                      00381000
         BNZ   FRSTRTRN                No, just return                  00382000
         SPACE ,                                                        00383000
         L     R5,WK1FID               -> first record                  00384000
         L     R4,WKBUFADR             -> buffer                        00385000
         L     R15,BUFFAD              -> where to store it             00386000
         ST    R4,0(,R15)              Save                             00387000
         L     R14,=A(FD_MDATAL)      Get length                        00388000
         L     R15,BUFLEN              -> where to store it             00389000
         ST    R14,0(,R15)             Save                             00390000
         MVC   0(FD_MDATAL,R4),0(R5)  Move the data to work buffer      00391000
         SR    R15,R15                 Get return code                  00392000
         B     FRSTRTRN                And return                       00393000
         SPACE ,                                                        00394000
FRSTRTRN DS    0H                                                       00395000
         L     R14,RC                                                   00396000
         ST    R15,0(,R14)                                              00397000
         L     R13,4(,R13)             Get caller's savearea            00398000
         LM    R14,R12,12(R13)         Restore his registers            00399000
         BR    R14                     Return                           00400000
         SPACE ,                                                        00401000
FRSTERR  DS    0H                      return an i/o error              00402000
         L     R15,=F'8'                                                00403000
         B     FRSTRTRN                And return                       00404000
         SPACE 3                                                        00405000
         LTORG                                                          00406000
         EJECT                                                          00407000
*********************************************************************** 00408000
*********************************************************************** 00409000
*                                                                     * 00410000
*                               L A S T                               * 00411000
*                                                                     * 00412000
*********************************************************************** 00413000
*********************************************************************** 00414000
         SPACE 3                                                        00415000
LAST     DS    0H                                                       00416000
*                                                                       00417000
*     We don't support LAST so return the invalid function code.        00418000
*                                                                       00419000
         LR    R11,R15                 Set up base register             00420000
         USING LAST,R11                Establish addressability         00421000
         L     R15,=F'12'              Set RC to BAD                    00422000
         L     R14,RC                                                   00423000
         ST    R15,0(,R14)                                              00424000
         L     R13,4(,R13)             Get caller's savearea            00425000
         LM    R14,R12,12(R13)         Restore his registers            00426000
         BR    R14                     Return                           00427000
         SPACE 3                                                        00428000
         LTORG                                                          00429000
         EJECT                                                          00430000
*********************************************************************** 00431000
*********************************************************************** 00432000
*                                                                     * 00433000
*                               N E X T                               * 00434000
*                                                                     * 00435000
*********************************************************************** 00436000
*********************************************************************** 00437000
         SPACE 3                                                        00438000
NEXT     DS    0H                                                       00439000
*                                                                       00440000
*     For NEXT, we just call GETRECRD.                                  00441000
*                                                                       00442000
*     If the immediately previous command was an RKEY, then we will     00443000
*     get a new copy (by default since WK1FID is 0).  A new copy is     00444000
*     then built by GETRECRD.  Once we return, we position within       00445000
*     the new copy to the next MASTER after the WKRKEY value.           00446000
*                                                                       00447000
         LR    R11,R15                 Set up base register             00448000
         USING NEXT,R11                Establish addressability         00449000
         SPACE ,                                                        00450000
         ICM   R15,15,PARENT           Find out if FIRST MASTER         00451000
         BZ    NEXTERR                 Ooops, shouldn't be zero         00452000
         CLI   WKRKEY,0                Are we NEXTing after RKEY?       00453000
         BE    NEXT_RECORD             No, just continue                00454000
         XC    WKCURFID,WKCURFID       Yes, force refresh               00455000
         SPACE ,                                                        00456000
NEXT_RECORD   DS     0H                                                 00457000
         $ICALL GETRECRD                                                00458000
         LTR   R15,R15                 Is RC zero?                      00459000
         BNZ   NEXTRTRN                No, just return                  00460000
         CLI   WKRKEY,0                Are we NEXTing after RKEY?       00461000
         BE    NEXT_MASTER             No, continue                     00462000
         L     R3,WKCURFID             Yes, -> first                    00463000
         USING FILE_DEF,R3             Define the base                  00464000
         SPACE ,                                                        00465000
*                                                                       00466000
*  We are NEXTing after an RKEY.  This means that we must be positioned 00467000
*  by this RKEY value.                                                  00468000
*                                                                       00469000
NEXT_NEXT     DS     0H                                                 00470000
         CLC   FD_DDNAME,WKRKEY        Is this the one?                 00471000
         BE    NEXT_NEXT_END           Yes, go to next                  00472000
         ICM   R3,15,FD_NADDR          No -> next                       00473000
         BNZ   NEXT_NEXT               And loop                         00474000
         B     NEXTEOF                 Not found = EOF                  00475000
         SPACE ,                                                        00476000
NEXT_NEXT_END DS     0H                                                 00477000
         ICM   R3,15,FD_NADDR         No -> next                        00478000
         BZ    NEXTEOF                 Not found = EOF                  00479000
         ST    R3,WKCURFID             Save this one as next            00480000
         DROP  R3                                                       00481000
         SPACE ,                                                        00482000
NEXT_MASTER   DS     0H                                                 00483000
         XC    WKRKEY,WKRKEY           No more RKEY                     00484000
         L     R5,WKCURFID             -> current record                00485000
         L     R4,WKBUFADR             -> buffer                        00486000
         L     R15,BUFFAD              -> where to store it             00487000
         ST    R4,0(,R15)              Save                             00488000
         L     R14,=A(FD_MDATAL)      Get length                        00489000
         L     R15,BUFLEN              -> where to store it             00490000
         ST    R14,0(,R15)             Save                             00491000
         MVC   0(FD_MDATAL,R4),0(R5)  Move the data to work buffer      00492000
         SR    R15,R15                 Set RC to zero                   00493000
         B     NEXTRTRN                And return                       00494000
         SPACE ,                                                        00495000
NEXTEOF       DS   0H                  No MASTER                        00496000
         XC    WKRKEY,WKRKEY           No more RKEY                     00497000
         LA    R15,4                   EOF error                        00498000
         B     NEXTRTRN                And return                       00499000
         SPACE ,                                                        00500000
NEXTSEG_EOF   DS   0H                  No segment                       00501000
         LA    R15,4                   EOF error                        00502000
         XC    WKCURSEG,WKCURSEG       Indicate none available          00503000
         B     NEXTRTRN                And return                       00504000
         SPACE 3                                                        00505000
NEXTRTRN DS    0H                                                       00506000
         L     R14,RC                                                   00507000
         ST    R15,0(,R14)                                              00508000
         L     R13,4(,R13)             Get caller's savearea            00509000
         LM    R14,R12,12(R13)         Restore his registers            00510000
         BR    R14                     Return                           00511000
         SPACE ,                                                        00512000
NEXTERR  DS    0H                      return an i/o error              00513000
         L     R15,=F'8'                                                00514000
         B     NEXTRTRN                And return                       00515000
         SPACE 3                                                        00516000
         LTORG                                                          00517000
         EJECT                                                          00518000
*********************************************************************** 00519000
*********************************************************************** 00520000
*                                                                     * 00521000
*                           P R E V I O U S                           * 00522000
*                                                                     * 00523000
*********************************************************************** 00524000
*********************************************************************** 00525000
         SPACE 3                                                        00526000
PREV     DS    0H                                                       00527000
*                                                                       00528000
*     We don't support PREVIOUS, so just return an invalid function     00529000
*     return code.                                                      00530000
*                                                                       00531000
         LR    R11,R15                 Set up base register             00532000
         USING PREV,R11                Establish addressability         00533000
         L     R15,=F'12'              Return BAD                       00534000
         L     R14,RC                                                   00535000
         ST    R15,0(,R14)                                              00536000
         L     R13,4(,R13)             Get caller's savearea            00537000
         LM    R14,R12,12(R13)         Restore his registers            00538000
         BR    R14                     Return                           00539000
         SPACE 3                                                        00540000
         LTORG                                                          00541000
         EJECT                                                          00542000
*********************************************************************** 00543000
*********************************************************************** 00544000
*                                                                     * 00545000
*                               R K E Y                               * 00546000
*                                                                     * 00547000
*********************************************************************** 00548000
*********************************************************************** 00549000
         SPACE 3                                                        00550000
RKEY     DS    0H                                                       00551000
*                                                                       00552000
*     For RKEY, we will walk the FILEDEF chain looking for the DDNAME.  00553000
*     If found, then we will build a record.  If not found, we will     00554000
*     return the "NO RECORD" return code.                               00555000
*                                                                       00556000
*     Before RKEYing, we need to get rid of any data that               00557000
*     exists.                                                           00558000
*                                                                       00559000
         LR    R11,R15                 Set up base register             00560000
         USING RKEY,R11                Establish addressability         00561000
         SPACE ,                                                        00562000
         ICM   R15,15,PARENT           Find out if MASTER               00563000
         BZ    RKEYERR                 Ooops, shouldn't be zero         00564000
         ICM   R3,15,WK1FID            See if any MASTERs               00565000
         BNZ   RKEY_FIRST              We have to get rid of these      00566000
         B     RKEY_MASTER             None, so we can find this one    00567000
         SPACE ,                                                        00568000
RKEY_FIRST     DS  0H                                                   00569000
         $ICALL DELLEVEL                                                00570000
         LTR   R15,R15                 Is RC zero?                      00571000
         BNZ   RKEYRTRN                No, just return                  00572000
         SPACE ,                                                        00573000
*                                                                       00574000
*  Any old data is gone.  Get the key value into the work area.         00575000
*  Then try to find it walking the FCBSECT chain.                       00576000
*                                                                       00577000
RKEY_MASTER    DS  0H                                                   00578000
         L     R2,KEYBUF               -> incoming value                00579000
         L     R3,KEYLEN               -> its length                    00580000
         L     R3,0(,R3)               And get the length               00581000
         LA    R0,WKRKEY               -> our work area                 00582000
         L     R1,=A(L'WKRKEY)         Get its length                   00583000
         ICM   R1,8,=C' '              Clear to blanks                  00584000
         ICM   R3,8,=C' '              Clear to blanks                  00585000
         MVCL  R0,R2                   Move value to work area          00586000
         SR    R2,R2                                                    00587000
         SPACE ,                                                        00588000
         USING NUCON,R0                                                 00589000
         SR    R2,R2                                                    00590000
         LH    R5,FCBNUM               Get the count                    00591000
         LTR   R5,R5                   Are there any?                   00592000
         BZ    RKEY_MASTER_END         If none, we are done             00593000
         ICM   R2,7,FCBFIRST+1         -> first                         00594000
         BZ    RKEY_MASTER_END         If none, we are done             00595000
         USING FCBSECT,R2              Define a base                    00596000
         SPACE ,                                                        00597000
*                                                                       00598000
*  Now we will follow the SYSTEM chain looking for the correct file-id. 00599000
*                                                                       00600000
RKEY_MASTER_NEXT    DS  0H                                              00601000
         CLC   FCBDD,WKRKEY            Is this the correct one?         00602000
         BE    RKEY_MASTER_FND         Yes                              00603000
         ICM   R2,7,FCBNEXT+1          Is there another?                00604000
         BNZ   RKEY_MASTER_NEXT        Got one, try it                  00605000
         B     RKEY_MASTER_END         None found                       00606000
         SPACE ,                                                        00607000
RKEY_MASTER_FND     DS  0H             R2 -> right FCB                  00608000
         $ICALL BUILDVM                Go build the SYSTEM data         00609000
         LTR   R15,R15                 Is RC zero?                      00610000
         BNZ   RKEYRTRN                No, just return                  00611000
         DROP  R2                                                       00612000
         B     RKEY_MASTER_END                                          00613000
         SPACE ,                                                        00614000
RKEY_MASTER_END     DS  0H                                              00615000
         ICM   R3,15,WKCURFID          -> current record                00616000
         BZ    RKEYEOF                 If none, then EOF                00617000
         L     R4,WKBUFADR             -> buffer                        00618000
         L     R15,BUFFAD              -> where to store it             00619000
         ST    R4,0(,R15)              Save                             00620000
         L     R14,=A(FD_MDATAL)      Get length                        00621000
         L     R15,BUFLEN              -> where to store it             00622000
         ST    R14,0(,R15)             Save                             00623000
         MVC   0(FD_MDATAL,R4),0(R3)  Move the data to work buffer      00624000
         SR    R15,R15                 Set RC to zero                   00625000
         B     RKEYRTRN                And return                       00626000
         SPACE ,                                                        00627000
RKEYRTRN      DS   0H                                                   00628000
         L     R14,RC                                                   00629000
         ST    R15,0(,R14)                                              00630000
         L     R13,4(,R13)             Get caller's savearea            00631000
         LM    R14,R12,12(R13)         Restore his registers            00632000
         BR    R14                     Return                           00633000
         SPACE ,                                                        00634000
RKEYEOF       DS   0H                  None found                       00635000
         L     R15,=F'4'               EOF error                        00636000
         B     RKEYRTRN                And return                       00637000
         SPACE ,                                                        00638000
RKEYERR  DS    0H                      return an i/o error              00639000
         L     R15,=F'8'                                                00640000
         B     RKEYRTRN                And return                       00641000
         SPACE 3                                                        00642000
         LTORG                                                          00643000
         EJECT                                                          00644000
*********************************************************************** 00645000
*********************************************************************** 00646000
*                                                                     * 00647000
*             A L L   S U B R O U T I N E S   F O L L O W             * 00648000
*                                                                     * 00649000
*********************************************************************** 00650000
*********************************************************************** 00651000
         EJECT                                                          00652000
*********************************************************************** 00653000
*********************************************************************** 00654000
*                                                                     * 00655000
*                          D E L L E V E L                            * 00656000
*                                                                     * 00657000
*********************************************************************** 00658000
*********************************************************************** 00659000
         SPACE 3                                                        00660000
DELLEVEL DS    0H                                                       00661000
*                                                                       00662000
*     This subroutine deletes all of the data buffers.                  00663000
*                                                                       00664000
         STM   R0,R15,WKSAVE02         Save caller's registers          00665000
         LR    R11,R15                 Set up base                      00666000
         USING DELLEVEL,R11                                             00667000
         SPACE 1                                                        00668000
         LA    R1,WKFIDSUB             -> anchor block                  00669000
         SUBPOOL RELEASE,NAME='FILE_DEF'    get rid of it all           00670000
         XC    WKFIDSUB,WKFIDSUB       Clear anchor                     00671000
         SPACE ,                                                        00672000
         XC    WK1FID,WK1FID           Clear the pointers               00673000
         XC    WKCURFID,WKCURFID       and this                         00674000
         XC    WKCURSEG,WKCURSEG                                        00675000
         XC    WKXFIDBF,WKXFIDBF                                        00676000
         XC    WKXDATBF,WKXDATBF                                        00677000
         XC    WKRKEY,WKRKEY           Also clear last RKEY value       00678000
DLVLRTRN DS    0H                                                       00679000
         LM    R0,R14,WKSAVE02         Restore registers                00680000
         SR    R15,R15                 Set return code                  00681000
         BR    R14                     Return to caller                 00682000
         SPACE 3                                                        00683000
         LTORG                                                          00684000
         EJECT                                                          00685000
*********************************************************************** 00686000
*********************************************************************** 00687000
*                                                                     * 00688000
*                          G E T R E C R D                            * 00689000
*                                                                     * 00690000
*********************************************************************** 00691000
*********************************************************************** 00692000
         SPACE 3                                                        00693000
GETRECRD DS    0H                                                       00694000
*                                                                       00695000
*     This subroutine gets the "next" record to be                      00696000
*     returned to NOMAD.                                                00697000
*                                                                       00698000
         SPACE ,                                                        00699000
         STM   R0,R15,WKSAVE02         Save the registers               00700000
         LR    R11,R15                                                  00701000
         USING GETRECRD,R11            Define base                      00702000
         ICM   R1,15,WKCURFID          -> current fid                   00703000
         BZ    GREC_FIRST              Oops, none                       00704000
         USING FILE_DEF,R1                                              00705000
         ICM   R1,15,FD_NADDR         -> Next                           00706000
         BZ    GRECEOF                 None                             00707000
         ST    R1,WKCURFID                                              00708000
         B     GRECGREC                                                 00709000
         DROP  R1                                                       00710000
         EJECT ,                                                        00711000
*                                                                       00712000
*  We need to initialize the data.  It may be a FIRST or just a         00713000
*  refresh for some reason.                                             00714000
*                                                                       00715000
GREC_FIRST    DS    0H                                                  00716000
         SPACE ,                                                        00717000
*                                                                       00718000
*   Walk the CMS FCB chain.                                             00719000
*                                                                       00720000
         USING NUCON,R0                Define NUCON DSECT               00721000
         ICM   R5,3,FCBNUM             Are there any FILEDEFs?          00722000
         BZ    GRECVM9                 No, done here                    00723000
         LA    R2,FCBFIRST             -> -> first FCB                  00724000
         USING FCBSECT,R2              Define the base                  00725000
         SPACE ,                                                        00726000
GRECVM2  DS    0H                                                       00727000
         ICM   R2,7,FCBNEXT+1          -> next one                      00728000
         BZ    GRECVM9                 Done here                        00729000
         $ICALL BUILDVM                Go build from this FCB           00730000
         BCT   R5,GRECVM2              If not zero, continue            00731000
         SPACE ,                                                        00732000
GRECVM9  DS    0H                                                       00733000
         B     GREC_END_FIRST                                           00734000
         SPACE ,                                                        00735000
GREC_END_FIRST    DS    0H                                              00736000
         L     R1,WK1FID               Make the first one current       00737000
         ST    R1,WKCURFID                                              00738000
         B     GRECGREC                                                 00739000
         SPACE 1                                                        00740000
GRECGREC DS    0H                                                       00741000
         LM    R0,R14,WKSAVE02         Restore registers                00742000
         SR    R15,R15                 Set return code                  00743000
         BR    R14                     Return to caller                 00744000
         SPACE 1                                                        00745000
GRECEOF  DS    0H                                                       00746000
         LM    R0,R14,WKSAVE02         Restore registers                00747000
         LA    R15,4                   Set return code                  00748000
         BR    R14                     Return to caller                 00749000
         SPACE 3                                                        00750000
         LTORG                                                          00751000
         EJECT                                                          00752000
*********************************************************************** 00753000
*********************************************************************** 00754000
*                                                                     * 00755000
*                          G E T B O T H                              * 00756000
*                                                                     * 00757000
*********************************************************************** 00758000
*********************************************************************** 00759000
         SPACE 3                                                        00760000
GETBOTH  DS    0H                                                       00761000
*                                                                       00762000
*     This subroutine gets and initializes the storage for a MASTER.    00763000
*                                                                       00764000
         SPACE ,                                                        00765000
         STM   R0,R15,WKSAVE05         Save the registers               00766000
         LR    R11,R15                                                  00767000
         USING GETBOTH,R11             Define base                      00768000
*                                                                       00769000
*   Go get a data buffer.  This routine also initializes most of        00770000
*   the data to &NAV and initializes the next/prev pointers.            00771000
*   The routine is $ICALLed.                                            00772000
*   Upon exit, R3 -> new data buffer and R4 -> new segment buffer.      00773000
*                                                                       00774000
         L     R0,=A(FD_MLEN)                                           00775000
         CMSSTOR OBTAIN,DWORDS=(0),SUBPOOL='FILE_DEF'                   00776000
         ST    R1,WKCURFID             Save address                     00777000
         LR    R3,R1                                                    00778000
         USING FILE_DEF,R3                                              00779000
*                                                                       00780000
*  Initialize the records.                                              00781000
*                                                                       00782000
         SR    R14,R14                 Get a zero                       00783000
         L     R1,WKSAVE05+4*R1        Restore caller's R1              00784000
         MVC   FD_DDNAME,0(R1)         Move in ddname                   00785000
         LA    R14,WK1FID              -> to where to store             00786000
         ICM   R1,15,WK1FID            is this the first?               00787000
         BNZ   GETB_SFREE_1            No, go find right spot           00788000
         ST    R3,WK1FID               Yes, save it                     00789000
         B     GETB_SFREE_9            Now go init                      00790000
         SPACE ,                                                        00791000
GETB_SFREE_1  DS   0H                                                   00792000
         CLC   FD_DDNAME,FD_DDNAME-FILE_DEF(R1)                         00793000
         BE    GETB_OLD                                                 00794000
         BL    GETB_LOW                                                 00795000
         LA    R14,FD_NADDR-FILE_DEF(,R1)    -> where to store          00796000
         ICM   R1,15,FD_NADDR-FILE_DEF(R1)   Get next                   00797000
         BNZ   GETB_SFREE_1                   And loop                  00798000
         SPACE ,                                                        00799000
GETB_LOW      DS   0H                                                   00800000
         ST    R3,0(,R14)              Chain this                       00801000
         ST    R1,FD_NADDR            And the next                      00802000
         B     GETB_SFREE_9                                             00803000
         SPACE ,                                                        00804000
GETB_OLD      DS   0H                                                   00805000
         LR    R3,R1                   Ignore new one                   00806000
         ST    R1,WKCURFID                                              00807000
         SPACE ,                                                        00808000
GETB_SFREE_9  DS   0H                                                   00809000
         SR    R14,R14                                                  00810000
*                                                                       00811000
*  Now initialize the segment.                                          00812000
*                                                                       00813000
         MVI   FD_DEVTYPE,GLOBNAV     Init to NAV                       00814000
         MVI   FD_DEVTYPE+1,X'00'                                       00815000
         MVI   FD_FILENAME,GLOBNAV                                      00816000
         MVC   FD_FILENAME+1,=7X'00'   to NAV                           00817000
         MVI   FD_FILETYPE,GLOBNAV                                      00818000
         MVC   FD_FILETYPE+1,=7X'00'   to NAV                           00819000
         MVI   FD_FILEMODE,GLOBNAV                                      00820000
         MVC   FD_FILEMODE+1,=7X'00'   to NAV                           00821000
         MVC   FD_RECFM,FD_FILENAME        RECFM                        00822000
         MVC   FD_LRECL,FD_FILENAME        LRECL                        00823000
         MVC   FD_BLKSIZE,FD_FILENAME      BLKSIZE                      00824000
         ST    R3,WKSAVE05+(R3*4)      Save the ->                      00825000
         LM    R0,R14,WKSAVE05         Restore registers                00826000
         SR    R15,R15                 Set return code                  00827000
         BR    R14                     Return to caller                 00828000
         SPACE 3                                                        00829000
         DROP  R3                                                       00830000
         SPACE 3                                                        00831000
         LTORG                                                          00832000
         EJECT                                                          00833000
*********************************************************************** 00834000
*********************************************************************** 00835000
*                                                                     * 00836000
*                          B U I L D V M                              * 00837000
*                                                                     * 00838000
*********************************************************************** 00839000
*********************************************************************** 00840000
         SPACE 3                                                        00841000
BUILDVM  DS    0H                                                       00842000
*                                                                       00843000
*     This subroutine builds a data record                              00844000
*     from the VM file control block -> by R2 upon entry.               00845000
*                                                                       00846000
         SPACE ,                                                        00847000
         STM   R0,R15,WKSAVE04         Save the registers               00848000
         LR    R11,R15                                                  00849000
         USING BUILDVM,R11             Define base                      00850000
         USING FCBSECT,R2                                               00851000
         USING FILE_DEF,R3             Define the base                  00852000
         SPACE ,                                                        00853000
BVM_NEXT2     DS   0H                                                   00854000
         LA    R1,FCBDD                -> current ddname                00855000
         $ICALL GETBOTH                                                 00856000
         MVC   FD_DDNAME(L'FCBDD),FCBDD                                 00857000
         SPACE ,                                                        00858000
         CLI   FCBDEV,FCBDSK           Is this disk?                    00859000
         BNE   BVM_SEG2B                                                00860000
         MVC   FD_FILENAME,FCBDSNAM                                     00861000
         MVC   FD_FILETYPE,FCBDSTYP                                     00862000
         CLI   FCBDSMD,0               Is there a filemode?             00863000
         BE    BVM_SEG2C               No                               00864000
         MVC   FD_FILEMODE,FCBDSMD     Yes, move it                     00865000
         B     BVM_SEG2C                                                00866000
         SPACE ,                                                        00867000
BVM_SEG2B     DS   0H                                                   00868000
         CLI   FCBDEV,FCBTAP           Is this a tape?                  00869000
         BNE   BVM_SEG2C                                                00870000
         SPACE ,                                                        00871000
BVM_SEG2C     DS   0H                                                   00872000
         CLC   FCBLRECL,=F'0'          Is there an LRECL?               00873000
         BE    BVM_BLKSIZE             No                               00874000
         XC    FD_LRECL,FD_LRECL       Yes, clear NAV                   00875000
         MVC   FD_LRECL+2(2),FCBLRECL    Get data                       00876000
         SPACE ,                                                        00877000
BVM_BLKSIZE   DS   0H                                                   00878000
         CLC   FCBBLKSZ,=F'0'          Is there a BLKSIZE?              00879000
         BE    BVM_RECFM               No                               00880000
         XC    FD_BLKSIZE,FD_BLKSIZE   Yes, clear NAV                   00881000
         MVC   FD_BLKSIZE+2(2),FCBBLKSZ    Get data                     00882000
         SPACE ,                                                        00883000
BVM_RECFM    DS    0H                                                   00884000
         TM   FCBRECFM,DCBRECU         Is RECFM undefined?              00885000
         BNO  BVM_RECFM2               No                               00886000
         MVC  FD_RECFM,=CL4'V'         We say variable                  00887000
         B    BVM_RECFM_B              Now go check blocking            00888000
         SPACE ,                                                        00889000
BVM_RECFM2   DS    0H                                                   00890000
         TM   FCBRECFM,DCBRECF         Is RECFM fixed?                  00891000
         BNO  BVM_RECFM3               No                               00892000
         MVC  FD_RECFM,=CL4'F'         Make it so                       00893000
         B    BVM_RECFM_B              Now go check blocking            00894000
         SPACE ,                                                        00895000
BVM_RECFM3   DS    0H                                                   00896000
         TM   FCBRECFM,DCBRECV         Is RECFM variable?               00897000
         BNO  BVM_RECFM9               No                               00898000
         MVC  FD_RECFM,=CL4'I'         Make it so                       00899000
         TM   FCBRECFM,DCBRECSB        Is it spanned?                   00900000
         BNO  BVM_RECFM_B              No go check blocked              00901000
         MVI  FD_RECFM+3,C'S'          Yes, make it so                  00902000
         B    BVM_RECFM_B              Now go check blocking            00903000
         SPACE ,                                                        00904000
BVM_RECFM_B  DS    0H                  Check for blocking               00905000
         TM   FCBRECFM,DCBRECBR        Are records blocked?             00906000
         BNO  BVM_RECFM_CC             No                               00907000
         MVI  FD_RECFM+1,C'B'          Yes, set it                      00908000
         SPACE ,                                                        00909000
BVM_RECFM_CC DS    0H                  Check for carriage control       00910000
         TM   FCBRECFM,DCBRECCA        is CC ASA on?                    00911000
         BNO  BVM_RECFM_CC2            No                               00912000
         MVI  FD_RECFM+2,C'A'          Yes, set it                      00913000
         B    BVM_RECFM9                                                00914000
         SPACE ,                                                        00915000
BVM_RECFM_CC2   DS    0H               Check for carriage control       00916000
         TM   FCBRECFM,DCBRECCM        is CC machine on?                00917000
         BNO  BVM_RECFM9               No                               00918000
         MVI  FD_RECFM+2,C'M'          Yes, set it                      00919000
         B    BVM_RECFM9                                                00920000
         SPACE ,                                                        00921000
BVM_RECFM9    DS    0H                                                  00922000
         SR    R15,R15                                                  00923000
         ICM   R15,1,FCBDEV            Get the device type              00924000
         B     BVM_DEVTYPE(R15)        And set it                       00925000
BVM_DEVTYPE DS    0H                                                    00926000
         B     BVM_DUMMY                                                00927000
         B     BVM_PRINTER                                              00928000
         B     BVM_READER                                               00929000
         B     BVM_TERM                                                 00930000
         B     BVM_TAPE                                                 00931000
         B     BVM_DISK                                                 00932000
         B     BVM_PUNCH                                                00933000
         B     BVM_CRT                                                  00934000
         SPACE ,                                                        00935000
BVM_DISK      DS    0H                 Device type = disk               00936000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_DI)                           00937000
         B     BVM_JOIN                                                 00938000
         SPACE ,                                                        00939000
BVM_TAPE      DS    0H                 Device type = tape               00940000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_TA)      Set it               00941000
         B     BVM_JOIN                                                 00942000
         SPACE ,                                                        00943000
BVM_DUMMY     DS    0H                 Device type = DUMMY              00944000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_OT)      Set it               00945000
         B     BVM_JOIN                                                 00946000
         SPACE ,                                                        00947000
BVM_PRINTER   DS    0H                 Device type = printer            00948000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_PT)      Set it               00949000
         B     BVM_JOIN                                                 00950000
         SPACE ,                                                        00951000
BVM_PUNCH     DS    0H                 Device type = punch              00952000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_SY)      Set it               00953000
         B     BVM_JOIN                                                 00954000
         SPACE ,                                                        00955000
BVM_READER    DS    0H                 Device type = reader             00956000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_OT)      Set it               00957000
         B     BVM_JOIN                                                 00958000
         SPACE ,                                                        00959000
BVM_TERM      DS    0H                 Device type = terminal           00960000
         SPACE ,                                                        00961000
BVM_CRT       DS    0H                 Device type = CRT                00962000
         MVC   FD_DEVTYPE,=AL2(FD_DEVTYPE_TE)      Set terminal         00963000
         B     BVM_JOIN                                                 00964000
         SPACE ,                                                        00965000
BVM_JOIN      DS    0H                 Done with device types           00966000
         SPACE ,                                                        00967000
         LM    R0,R14,WKSAVE04         Restore registers                00968000
         SR    R15,R15                 Set return code                  00969000
         BR    R14                     Return to caller                 00970000
         SPACE 3                                                        00971000
         DROP  R2,R3                                                    00972000
         SPACE 3                                                        00973000
         LTORG                                                          00974000
         EJECT                                                          00975000
*********************************************************************** 00976000
*********************************************************************** 00977000
*                                                                     * 00978000
*                         C O N S T A N T S                           * 00979000
*                                                                     * 00980000
*********************************************************************** 00981000
*********************************************************************** 00982000
         SPACE 3                                                        00983000
OPCTABLE DC    A(0,OPEN,CLOSE,SHUTDOWN,FIRST,NEXT,0,0,0,RKEY,0,0,LAST,PX00984000
               REV)                                                     00985000
         SPACE 3                                                        00986000
         END                                                            00987000
